﻿Include "MSAAConst.jsh"
Include "hjconst.jsh"
Include "hjglobal.jsh"
Include "common.jsm"
include "UIA.jsh"

Include "ewMenus.jsh" 
include "ewMenus.jsm"

; -------------------------------------------------------------------------------------------------------
; Erstellt das globale XML-Objekt 
; -------------------------------------------------------------------------------------------------------

void function NewXmlMenu (optional string sName)
var object oMenu 
var object oIntro 
; bereits vorhandenes Objekt freigeben 
goXML = Null ()
; Microsoft XML-Objekt erstellen 
goXML = CreateObject("msxml2.DOMDocument.6.0")
; Einstellungen vornehmen 
goXML.async = false;
goXML.resolveExternals = false;
goXML.setProperty("SelectionLanguage", "XPath")
; Element "Menüs" erstellen , unter welchem später die Menüleiste und Menüpunkte erstellt werden 
oMenu = goXML.createElement(cMenusElement)
; wenn ein Name für die Menüsammlung angegeben wurde 
If !sName == "" then
; diesen als Attribut hinzufügen 
oMenu.SetAttribute(cNameAttribute, sName)
EndIf ; If !sName == "" then
goXML.appendChild(oMenu)
oIntro = goXML.createProcessingInstruction("xml","version='1.0'")
goXML.insertBefore(oIntro, goXML.childNodes(0))
oMenu = Null ()
oIntro = Null ()
EndFunction

; -------------------------------------------------------------------------------------------------------
; Hilfsfunktion zum Erstellen eines Menüpunkts
; -------------------------------------------------------------------------------------------------------

void function CreateMenu(string sMenuname)
var object oMenuEntry
var object oMenu
; Menüleisten-Eintrag generieren 
oMenuEntry = goXML.createElement(cMenuElement);
; Namen festlegen
oMenuEntry.Text = sMenuname
; Element "Menüs" auswählen 
oMenu = goXML.getElementsByTagName(cMenusElement).item(0)
; als letztes Element das generierte Menü einfügen 
oMenu.appendChild(oMenuEntry)
; Objekte freigeben 
oMenuEntry = Null ()
oMenu = Null ()
EndFunction

; -------------------------------------------------------------------------------------------------------
; Hilfsfunktion zum Erstellen eines Menüeintrags 
; -------------------------------------------------------------------------------------------------------

void function CreateMenuEntry (string sMenuEntryName, string sShortcut, string sCommand, string sParam)
var object oMenuEntry
var object oMenu
; die Positions-Nummer des letzten Menüs ermitteln 
var int iLastChild = goXML.getElementsByTagName(cMenuElement).length - 1
; Menü-Eintrag generieren 
oMenuEntry = goXML.createElement(cMenuEntryElement);
; Namen zuweisen 
oMenuEntry.Text = sMenuEntryname
; Falls ein Shortcut als Parameter angegeben ist 
If !sShortcut == "" then
; diesen als Attribut "shortcut" hinzufügen 
oMenuEntry.SetAttribute(cShortcutAttribute, sShortcut)
EndIf ; If !sShortcut == "" then
; den Befehl als Attribut "command" hinzufügen 
oMenuEntry.SetAttribute(cCommandAttribute, sCommand)
; den Parameter als Attribut "param" hinzufügen 
oMenuEntry.SetAttribute(cParamAttribute, sParam)
; den letzten Menüpunkt als XML-Objekt erhalten 
oMenu = goXML.getElementsByTagName(cMenuElement).item(iLastChild)
; und diesem als letzten Eintrag den oben erstellten Menü-Eintrag-Elements hinzufügen 
oMenu.appendChild(oMenuEntry)
; Objekte freigeben 
oMenuEntry = Null ()
oMenu = Null ()
EndFunction

; -------------------------------------------------------------------------------------------------------
; Hilfsfunktion zum erstellen eines Untermenüs 
; -------------------------------------------------------------------------------------------------------

void function CreateSubMenuEntry (string sMenuEntryName, string sShortcut, string sCommand, string sParam)
var object oMenuEntry
var object oMenu
; die Positions-Nummer des letzten Menüeintrags ermitteln 
var int iLastChild = goXML.getElementsByTagName(cMenuEntryElement).length - 1
; Untermenü-Eintrag generieren 
oMenuEntry = goXML.createElement(cSubmenuEntryElement);
; Namen zuweisen 
oMenuEntry.Text = sMenuEntryname
; Falls ein Shortcut als Parameter angegeben ist 
If !sShortcut == "" then
; diesen als Attribut "shortcut" hinzufügen 
oMenuEntry.SetAttribute(cShortcutAttribute, sShortcut)
EndIf ; If !sShortcut == "" then

; den Befehl als Attribut "command" hinzufügen 
oMenuEntry.SetAttribute(cCommandAttribute, sCommand)
; den Parameter als Attribut "param" hinzufügen 
oMenuEntry.SetAttribute(cParamAttribute, sParam)
; den letzten Menüeintrag als XML-Objekt erhalten 
oMenu = goXML.getElementsByTagName(cMenuEntryElement).item(iLastChild)
; und diesem als letzten Eintrag dem oben erstellten Untermenü-Eintrag-Element hinzufügen 
oMenu.appendChild(oMenuEntry)
; Objekte freigeben 
oMenuEntry = Null ()
oMenu = Null ()
EndFunction

; -------------------------------------------------------------------------------------------------------
; Löscht den XML-Inhalt des MS-XML-Objects (nicht das Objekt selbst)
; -------------------------------------------------------------------------------------------------------

Void Function ClearXML ()
goXML.Load("")
EndFunction

; -------------------------------------------------------------------------------------------------------
; speichert XML-Inhalt auf der Festplatte (vorhandenes XML wird überschrieben)
; -------------------------------------------------------------------------------------------------------

Void Function SaveXML (string sFilename)
goXML.save(sFilename)
EndFunction

; -------------------------------------------------------------------------------------------------------
; XML-Datei von der Festplatte laden
; -------------------------------------------------------------------------------------------------------

Void Function LoadXML (string sFilename)
; Wenn die Datei existiert 
If FileExists (sFilename) then
; diese ins globale XML-Objekt laden 
goXML.load(sFilename)
else
SayFormattedMessage (OT_ERROR, msgNoFile_L, msgNoFile_S, sFilename)
EndIf ; If FileExists (sFilename) then
EndFunction

; -------------------------------------------------------------------------------------------------------
; zeigt eine XML-Datei im Browser an
; -------------------------------------------------------------------------------------------------------

Void Function OpenXML (string sFilename)
; wenn die Datei existiert 
If FileExists (sFilename) then
; Datei im Browser öffnen
Run(sFilename)
else
SayFormattedMessage (OT_ERROR, msgNoFile_L, msgNoFile_S, sFilename)
EndIf ; If FileExists (sFilename) then
EndFunction

; -------------------------------------------------------------------------------------------------------
; Gibt das globale XML-Objekct zurück (funktioniert nicht 
; aus anderen Scriptdateien heraus)
; -------------------------------------------------------------------------------------------------------

object Function GetXMLObject()
Return goXML
EndFunction

; -------------------------------------------------------------------------------------------------------
; Gibt den globalen XML als Zeichenkette zurück (funktioniert nicht 
; aus anderen Scriptdateien heraus)
; -------------------------------------------------------------------------------------------------------

string Function GetXMLString()
Return goXML.xml
EndFunction

; -------------------------------------------------------------------------------------------------------
; Menüleiste als Zeichenkette erhalten 
; -------------------------------------------------------------------------------------------------------

string Function GetMenuBar()
; alle Menüs in Objekt ElementList laden
var object ElementList = goXML.GetElementsByTagName(cMenuElement)
var int i
var string sAllMenus
var string sActMenu
; Schleife über alle Elemente der (Menü-)Sammlung
for i = 0 to ElementList.Length- 1
; Text des aktuellen Menüs erhalten 
sActMenu = ElementList(i).FirstChild.Text 
; und zur Liste sAllmenus hinzufügen 
sAllMenus = sAllMenus + sActMenu + "|"
EndFor ; for i = 0 to ElementList.Length- 1
; den letzten senkrechten Strich aus der Sammlung entfernen 
sAllMenus  = StringLeft (sAllmenus, StringLength(sAllmenus)-1)
; Ergebnis zurückgeben 
Return sAllMenus
EndFunction

; -------------------------------------------------------------------------------------------------------
; Menüeinträge eines Menüs als Zeichenkette erhalten 
; -------------------------------------------------------------------------------------------------------

string Function GetMenuEntries (int iPos)
; XPath-Ausdruck anhand der Menünummer erstellen 
var string sPath = "//"+cMenuElement+"[" + IntToString(iPos) + "]/"+cMenuEntryElement
; XPath-Ausdruck anwenden 
var object ElementList = goXML.documentElement.selectNodes(sPath)
var string sAllMenus
var string sActMenu
var int i
; Schleife über alle Elemente der Menüeinträge 
for i = 0 to ElementList.Length- 1
; Text des Menüeintrags ermitteln 
sActMenu = elementList(i).FirstChild.Text
; zur Liste aller Menüeinträge hinzufügen 
sAllMenus  = sAllMenus + sActMenu + "|"
EndFor ; for i = 0 to ElementList.Length- 1
; letzten senkrechten Strich entfernen 
sAllMenus = StringLeft (sAllMenus, StringLength(sAllMenus)-1)
; und als Ergebnis der Funktion zurückgeben 
Return sAllMenus
EndFunction

; -------------------------------------------------------------------------------------------------------
; Menüeinträge eines Untermenüs als Zeichenkette erhalten 
; -------------------------------------------------------------------------------------------------------

string Function GetSubMenuEntries (int iPosMenu, int iPosMenuentry)
; XPath-Ausdruck anhand der Menünummer und der Menüeintragnummer erstellen 
var string sPath = "//"+cMenuElement+"[" + IntToString(iPosMenu) + "]/"+cMenuEntryElement+"["+IntToString(iPosMenuentry)+"]/"+cSubmenuEntryElement
; XPath-Ausdruck anwenden 
var object ElementList = goXML.documentElement.selectNodes(sPath)
var string sAllMenus
var string sActMenu
var int i
; Schleife über alle Elemente der Untermenüeinträge 
for i = 0 to ElementList.Length- 1
; Text des Untermenüeintrags ermitteln 
sActMenu = elementList(i).FirstChild.Text
; zur Liste aller Menüeinträge hinzufügen 
sAllMenus  = sAllMenus + sActMenu + "|"
EndFor ; for i = 0 to ElementList.Length- 1
; letzten senkrechten Strich entfernen 
sAllMenus = StringLeft (sAllMenus, StringLength(sAllMenus)-1)
; und als Ergebnis der Funktion zurückgeben 
Return sAllMenus
EndFunction

; -------------------------------------------------------------------------------------------------------
; Parameter-Attribut eines Menüpunkts auslesen 
; -------------------------------------------------------------------------------------------------------

string Function GetMenuParam (int iMenuPos, int iMenuEntryPos)
Return goXML.selectSingleNode("//"+cMenuElement+"["+IntToString(iMenuPos)+"]/"+cMenuEntryElement+"["+IntToString(iMenuEntryPos)+"]/@param").text
EndFunction

; -------------------------------------------------------------------------------------------------------
; Shortcut-Attribut eines Menüpunkts auslesen 
; -------------------------------------------------------------------------------------------------------

string Function GetMenuShortcut (int iMenuPos, int iMenuEntryPos)
Return goXML.selectSingleNode("//"+cMenuElement+"["+IntToString(iMenuPos)+"]/menuentry["+IntToString(iMenuEntryPos)+"]/@shortcut").text
EndFunction

; -------------------------------------------------------------------------------------------------------
; Command-Attribut eines Menüpunkts auslesen 
; -------------------------------------------------------------------------------------------------------

string Function GetMenuCommand (int iMenuPos, int iMenuEntryPos)
Return goXML.selectSingleNode("//"+cMenuElement+"["+IntToString(iMenuPos)+"]/"+cMenuEntryElement+"["+IntToString(iMenuEntryPos)+"]/@command").text
EndFunction

; -------------------------------------------------------------------------------------------------------
; den Namem (Bezeichnung) des Menüs auslesen 
; -------------------------------------------------------------------------------------------------------

string Function GetMenuName ()
Return goXML.selectSingleNode("//menus/@name").text
EndFunction

; -------------------------------------------------------------------------------------------------------
; Parameter-Attribut eines Untermenüs auslesen 
; -------------------------------------------------------------------------------------------------------

string Function GetSubMenuParam (int iMenuPos, int iMenuEntryPos, int iSubMenuEntryPos)
Return goXML.selectSingleNode("//"+cMenuElement+"["+IntToString(iMenuPos)+"]/"+cMenuEntryElement+"["+IntToString(iMenuEntryPos)+"]/"+cSubmenuEntryElement+"["+IntToString(iSubMenuEntryPos)+"]/@param").text
EndFunction

; -------------------------------------------------------------------------------------------------------
; Shortcut-Attribut eines Untermenüs auslesen 
; -------------------------------------------------------------------------------------------------------

string Function GetSubMenuShortcut (int iMenuPos, int iMenuEntryPos, int iSubMenuEntryPos)
Return goXML.selectSingleNode("//"+cMenuElement+"["+IntToString(iMenuPos)+"]/"+cMenuEntryElement+"["+IntToString(iMenuEntryPos)+"]/"+cSubmenuEntryElement+"["+IntToString(iSubMenuEntryPos)+"]/@shortcut").text
EndFunction

; -------------------------------------------------------------------------------------------------------
; Command-Attribut eines Untermenüs auslesen 
; -------------------------------------------------------------------------------------------------------

string Function GetSubMenuCommand (int iMenuPos, int iMenuEntryPos, int iSubMenuEntryPos)
Return goXML.selectSingleNode("//"+cMenuElement+"["+IntToString(iMenuPos)+"]/"+cMenuEntryElement+"["+IntToString(iMenuEntryPos)+"]/"+cSubmenuEntryElement+"["+IntToString(iSubMenuEntryPos)+"]/@command").text
EndFunction

; -------------------------------------------------------------------------------------------------------
; Menüs starten, ersten Menüpunkt darstellen sowie Einstellungen vornehmen 
; -------------------------------------------------------------------------------------------------------

Function StartMenuLayer()
var
; Taste ermitteln, mit der das Menü aufgerufen wurde 
string sKey = GetCurrentScriptKeyName ()
; Wenn die Menüs eingeschaltet sind 
If giMenus then
; Taste an Funktion "FindChar" zum Suchen der Kurztaste weiterreichen 
PerformScript FindChar(sKey)
; uns Script verlassen 
return
EndIf ; If giMenus then

; Menüs wurden noch nicht eingeschaltet, deshalb initialisieren 

; Bildschirm einfärben als Zeichen, dass die Menüs aktiv sind
ShowRectangleWindow(0, 0, ScreenGetWidth (), ScreenGetHeight ())

; global merken, dass Menüs eingeschaltet sind 
giMenus = True
; Sound abspielen 
PlaySound (FindJAWSSoundFile (cStartMenus, False))
; Falls vorhanden, Menünamen sprechen 
SayFormattedMessage (OT_SCREEN_MESSAGE, GetMenuName(), GetMenuName ())

; Braille-Message "Menünamen" hinzufügen
BrailleString (GetMenuName())

; Startmeldung sprechen
SayFormattedMessage (OT_SCREEN_MESSAGE, msgStartMenuLayer_L, msgStartMenuLayer_S)

; Startmeldung zur Flash-Message hinzufügen
BrailleMessage (msgStartMenuLayer_S, 1, 50000)

; Menü-Einträge ermitteln und global speichern 
gsMenuBar = GetMenuBar()
; aktuelle Position der Menüleiste auf 1 setzen 
giMenuBarPos = 1
; die Anzahl der Menüs ermitteln 
giMenuBarMax = StringSegmentCount (gsMenuBar, "|")
; Status auf cMenubarActive (nur Menüleiste wird angezeigt) stellen 
giMenuStatus = cMenubarActive
; Menüeinträge ermitteln und global speichern 
gsMenuEntries = GetMenuEntries (giMenuBarPos)
; Position der Menüeinträge auf 0, d. h. wird (noch) nicht angezeigt 
giMenuEntryPos = 0
; Anzahl der Menüeinträge ermitteln 
giMenuEntryMax = StringSegmentCount (gsMenuEntries, "|")
; und aktuellen Eintrag sprechen 
SayPosition()
EndFunction

; -------------------------------------------------------------------------------------------------------
; Event-Funktion wird ausgelöst, wenn kombinierte Tasten gedrückt werden 
; - wird zurzeit noch nicht genutzt - 
; -------------------------------------------------------------------------------------------------------

void function KeymapChangedEvent(int iKeyCode, string sKeyName, int iKeyStatus)
; Konstanten aus der HJConst.jsh
; KeySequenceComplete = 0,
; KeySequenceRepeating = 1,
; KeySequencePending = 2,
; KeySequenceCanceled = 3,
; KeySequenceStart = 4,
; KeySequenceRestarted = 5,

If (iKeyStatus == KeySequenceComplete) || (iKeyStatus == KeySequenceCanceled) then
BrailleRefresh ()
EndIf

; Event an andere Skriptdateien weiterreichen 
KeymapChangedEvent(iKeyCode, sKeyName, iKeyStatus)
EndFunction

; -------------------------------------------------------------------------------------------------------
; Beenden des Menüs, Meldung sprechen
; -------------------------------------------------------------------------------------------------------

Script ExitMenuLayer()
	; Einfärbung des Bildschirms ausschalten 
UpdateUIAElementRectangle ()

; global merken, dass Menüs ausgeschaltet sind 
giMenus = False
; Sound abspielen ...
PlaySound (FindJAWSSoundFile (cExitMenus, False))
; ... und Meldung sprechen 
SayFormattedMessage (OT_SCREEN_MESSAGE, msgExitMenuLayer_L, msgExitMenuLayer_S)
BrailleString (msgExitMenuLayer_S)
; JAWS-Funktion zum Beenden der Tasten-Sequenz ausführen 
CancelLayeredKeySequence()
; Objekte freigeben und Werte (für nächstes Menü) auf zurücksetzen
goXML = Null ()
giMenuStatus = 0
gsMenuBar = ""
giMenuBarPos = 0
giMenuBarMax = 0
gsMenuEntries = ""
giMenuEntryPos = 0
giMenuEntryMax = 0
gsSubMenuEntries = ""
giSubMenuEntryPos = 0
giSubMenuEntryMax = 0
gsParam = ""
gsCommand = ""
gsShortcut = ""
EndScript

; -------------------------------------------------------------------------------------------------------
; im Menü bewegen  
; -------------------------------------------------------------------------------------------------------

Script ChangeMenuPosition (int iDirection)

; wenn wir uns nach links bewegen 
If iDirection == cLeft then
      ; und falls ein Untermenü geöffnet ist 
      If giMenuStatus == cSubmenuIsOpen then
      ; wird der Status von cSubmenuOpen (geöffnetes Untermenü)
      ; auf cSubmenu (Untermenü verfügbar, aber nicht geöffnet) gestellt 
      giMenuStatus = cSubmenu
      ; ankündigen, dass das Untermenü jetzt geschlossen ist 
     SayFormattedMessage (OT_SCREEN_MESSAGE, msgCloseSubMenu_L, msgCloseSubMenu_S)
      ; und aktuelle Position (Menüeintrag) sprechen 
      SayPosition()
      else ; andernfalls handelt es sich nicht um ein Untermenü, d. h. 
      ; wir bewegen uns im Menü
      ; deshalb wechselt der Status auf cMenubarActive 
      giMenuStatus = cMenubarActive
      ; die aktuelle Menüposition wird um 1 verringert 
      giMenuBarPos = giMenuBarPos -1
            ; wenn wir uns vor dem ersten Menüpunkt befinden
            If giMenuBarPos == 0 then
            ; wechseln wir zum letzten Menüpunkt 
            giMenuBarPos = giMenuBarMax
            ; und kündigen dies an 
            SayFormattedMessage (OT_SCREEN_MESSAGE, msgFromBeginToEnd_L, msgFromBeginToEnd_S)
            EndIf ; If giMenuBarPos = 0 then
      ; da die Menü-Position nun geklärt ist, ermitteln wir die Menüeinträge 
      gsMenuEntries = GetMenuEntries (giMenuBarPos)
      ; und stellen die Position auf 0 (d. h. nichts wird angezeigt, da wir uns in der Menüleiste befinden)
      giMenuEntryPos = 0
      ; ermitteln der Anzahl der Menüeinträge 
      giMenuEntryMax = StringSegmentCount (gsMenuEntries, "|")
      ; und aktuelle Position (in der Menüleiste) sprechen 
      SayPosition()
      EndIf ; If gIMenuStatus = cSubmenuIsOpen then
EndIf ; If iDirection == cLeft then

; wenn wir uns nach oben bewegen 
If iDirection == cUp then
      ; Wenn noch kein Menü geöffnet ist (wir also auch nicht im Untermenü sind)
      If giMenuEntryPos == 0 then 
            ; wenn hier keine Einträge sind, dies melden und Skript verlassen 
            If giMenuEntryMax == 0 then
            SayFormattedMessage (OT_SCREEN_MESSAGE, msgNoMenuEntries_L, msgNoMenuEntries_S)
            Return
            EndIf ; If giMenuEntryMax = 0 then
      ; aktivieren wir den ersten Eintrag 
      giMenuEntryPos =1 
      EndIf ; If giMenuEntryPos == 0 then
      ; wenn ein Untermenü geöffnet ist 
      If giMenuStatus == cSubmenuIsOpen then
      ; gehen wir einen Eintrag weiter nach oben 
      giSubMenuEntryPos = giSubMenuEntryPos - 1
            ; wenn wir vor dem ersten Eintrag des Untermenüs sind
            If giSubMenuEntryPos == 0 then
            ; gehen wir zum letzten Untermenüeintrag 
            giSubMenuEntryPos = giSubMenuEntryMax
            ; und kündigen dies an 
            SayFormattedMessage (OT_SCREEN_MESSAGE, msgFromEndToBegin_L, msgFromEndToBegin_S)
            EndIf ; If giSubMenuEntryPos == -1 then
            ; Eintrag sprechen 
            SayPosition ()
      else ; es ist kein Untermenü geöffnet, wir befinden uns in einem Menü
      ; Menü-Status speichern 
      giMenuStatus = cMenusOpen 
      ; ein Eintrag weiter nach oben 
      giMenuEntryPos = giMenuEntryPos - 1
            ; wenn wir vor dem ersten Menü-Eintrag sind
            If giMenuEntryPos == 0 then
            ; gehen wir ans Ende der Menü-Einträge
            giMenuEntryPos = giMenuEntryMax
            ; und kündigen dies an 
            SayFormattedMessage (OT_SCREEN_MESSAGE, msgFromBeginToEnd_L, msgFromBeginToEnd_S)
            EndIf ; If giMenuEntryPos == 0 then
      ; Eintrag sprechen 
      SayPosition ()
      EndIf ; If giMenuStatus == cSubmenuIsOpen then
EndIf ; If iDirection == cUp then

; wenn wir uns nach rechts bewegen 
If iDirection == cRight then
    ; und wir uns (bereits) in einem Untermenü befinden 
    If giMenuStatus == cSubmenuIsOpen then
    ; dies Ankündigen 
    SayFormattedMessage (OT_SCREEN_MESSAGE, msgSubmenuIsAlreadyOpen_L, msgSubmenuIsAlreadyOpen_S)
    ; und Script verlassen 
    Return
    EndIf ; If giMenuStatus == cSubmenuIsOpen then
    ; wenn ein Untermenü erkannt, jedoch noch nicht geöffnet ist 
    If giMenuStatus == cSubmenu then
    ; Untermenüeinträge laden 
    gsSubMenuEntries  = GetSubMenuEntries (giMenuBarPos, giMenuEntryPos)
    ; und ersten Untermenüeintrag aktivieren 
    giSubMenuEntryPos = 1
    ; Anzahl Untermenüeinträge ermitteln 
    giSubMenuEntryMax = StringSegmentCount (gsSubMenuEntries, "|")
    ; und Anzahl Einträge mitteilen 
    SayFormattedMessage (OT_SCREEN_MESSAGE, msgOpenSubmenu_L, msgOpenSubmenu_S, giSubMenuEntryMax)
    ; Menü-Status auf "Untermenü geöffnet" stellen 
    giMenuStatus = cSubmenuIsOpen
    ; Eintrag sprechen 
    SayPosition()
    else ; keine Untermenüs vorhanden oder geöffnet, also 
    ; Bewegen in der Menüleiste, Menüstatus merken
    giMenuStatus = cMenubarActive
    ; einen Eintrag weiter nacht rechts in der Menüleiste 
    giMenuBarPos = giMenuBarPos+1
        ; wenn wir uns in der Menüleiste hinter dem letzten Menü befinden 
        If giMenuBarPos > giMenuBarMax then
        ; zum ersten Menü gehen 
        giMenuBarPos = 1
        ; und Meldung sprechen
        SayFormattedMessage (OT_SCREEN_MESSAGE, msgFromEndToBegin_L, msgFromEndToBegin_S)
        EndIf ; If giMenuBarPos > giMenuBarMax then
    ; die Menüeinträge vorab laden 
    gsMenuEntries = GetMenuEntries (giMenuBarPos)
    ; aber nicht anzeigen
    giMenuEntryPos = 0
    ; Anzahl an Menüeinträgen ermitteln 
    giMenuEntryMax = StringSegmentCount (gsMenuEntries, "|")
    ; aktuelles Menü sprechen 
    SayPosition()
    EndIf ; If giMenuStatus == cSubmenu then
EndIf ; If iDirection == cRight then

; wenn wir uns nach unten bewegen 
If iDirection == cDown then
      ; wenn noch kein Menü geöffnet ist (wir also auch nicht im Untermenü sind)
      If giMenuEntryPos == 0 then 
            ; wenn hier keine Einträge sind, dies melden und Skript verlassen 
            If giMenuEntryMax == 0 then
            SayFormattedMessage (OT_SCREEN_MESSAGE, msgNoMenuEntries_L, msgNoMenuEntries_S)
            Return
            EndIf ; If giMenuEntryMax = 0 then
      EndIf ; If giMenuEntryPos == 0 then
      ; wenn ein Untermenü geöffnet ist 
      If giMenuStatus == cSubmenuIsOpen then
      ; einen Eintrag weiter nach unten im Untermenü gehen 
      giSubMenuEntryPos = giSubMenuEntryPos + 1
            ; wenn wir uns hinter dem letzten Eintrag im Untermenü befinden 
            If giSubMenuEntryPos > giSubMenuEntryMax then
            ; zum ersten Untermenüeintrag wechseln 
            giSubMenuEntryPos = 1
            ; und dies melden 
            SayFormattedMessage (OT_SCREEN_MESSAGE, msgFromEndToBegin_L, msgFromEndToBegin_S)
            EndIf ; If giSubMenuEntryPos == giSubMenuEntryMax then
            ; aktuellen Eintrag sprechen 
            SayPosition ()
      else ; wir sind nicht in einem Untermenü, also bewegen wir uns im Menü nach unten 
      ; Menü-Status auf geöffnetes Menü stellen 
      giMenuStatus = cMenusOpen 
           ; wenn wir uns aus der Menüleiste ins Menü bewegen (vorherige Position = 0)
           ; und Einträge vorhanden sind 
           If (giMenuEntryPos == 0) && (giMenuEntryMax > 0) then
           ; Status und Einträge sprechen 
           SayFormattedMessage (OT_SCREEN_MESSAGE, msgOpenMenu_L, msgOpenMenu_S, giMenuEntryMax)
           EndIf ; If (giMenuEntryPos == 0) && (giMenuEntryMax > 0) then
      ; Meinü-Eintrag-Position nach unten bewegen
      giMenuEntryPos = giMenuEntryPos + 1
            ; wenn wir uns hinter dem letzten Eintrag befinden 
            If giMenuEntryPos > giMenuEntryMax then
            ; ersten Menüeintrag aktivieren 
            giMenuEntryPos = 1
            ; und dies melden 
            SayFormattedMessage (OT_SCREEN_MESSAGE, msgFromEndToBegin_L, msgFromEndToBegin_S)
            EndIf ; If giMenuEntryPos == giMenuEntryMax then
      ; aktuellen Eintrag sprechen 
      SayPosition ()
      EndIf ; If MenuStatus = cSubmenuIsOpen then
EndIf ; If iDirection == cDown then

; wenn ein Menü geöffnet werden soll
If iDirection == cOpen then
    ; wenn der MenuStatus anzeigt, dass die Menüleiste aktiviert ist 
    If giMenuStatus == cMenubarActive then
    ; Pfeil-nach-unten-Taste senden 
    PerformScript ChangeMenuPosition (cDown)
    ; und Script verlassen 
    Return
    EndIf ; If giMenuStatus == cMenubarActive then

    ; wenn die Menüs bereits geöffnet sind, 
    If giMenuStatus == cMenusOpen then
    ; diese wieder schließen 
    PerformScript ChangeMenuPosition (cClose)
    EndIf ; If giMenuStatus == cMenusOpen then

    ; Wenn ein Menüeintrag ein Untermenü ankündigt 
    If giMenuStatus == cSubmenu then
    ; Pfeil-nach-rechts-Taste senden
    PerformScript ChangeMenuPosition (cRight)
    Return
    EndIf ; If giMenuStatus == cSubmenu then

    ; Wenn ein Untermenü geöffnet ist 
    If giMenuStatus == cSubmenuIsOpen then
    ; dieses wieder schließen 
    PerformScript ChangeMenuPosition (cLeft)
    Return
    EndIf ; If giMenuStatus == cSubmenuIsOpen then
EndIf ; If iDirection == cOpen then

; wenn die Taste für "zum Anfang" gedrückt wurde 
If iDirection == cFirst then
    ; und wenn Untermenüs geöffnet sind 
    If giMenuStatus == cSubmenuIsOpen  then
    ; Position auf ersten Eintrag setzen
    giSubMenuEntryPos = 1
    ; und dies melden
    SayFormattedMessage (OT_SCREEN_MESSAGE, msgFirstSubmenuEntry_L, msgFirstSubmenuEntry_S)
    ; sowie den Eintrag vorlesen 
    SayPosition()    
    EndIf ; If giMenuStatus == cSubmenuIsOpen  then
    ; wenn das Menü geöffnet ist 
    If (giMenuStatus == cMenusOpen) || (giMenuStatus == cSubmenu ) then
    ; Position auf ersten Eintrag setzen
    giMenuEntryPos = 1
    ; und dies melden 
    SayFormattedMessage (OT_SCREEN_MESSAGE, msgFirstMenuEntry_L, msgFirstMenuEntry_S)
    ; sowie den Eintrag vorlesen 
    SayPosition()
    EndIf ; If (giMenuStatus == cMenusOpen) || (giMenuStatus == cSubmenu ) then
    ; Wenn keine Menüs geöffnet sind 
    If giMenuStatus == cMenubarActive then
    ; neue Position in der Menü-Leiste auf das erste Menü setzen
    giMenuBarPos = 1
    ; Menü hat sich geändert, deshalb Menüeinträge laden 
    gsMenuEntries = GetMenuEntries (giMenuBarPos)
    ; Position der Menüeinträge auf 0 stellen (da Menüleiste aktiv ist)
    giMenuEntryPos = 0
    ; Anzahl Menüeinträge ermitteln 
    giMenuEntryMax = StringSegmentCount (gsMenuEntries, "|")
    ; Meldung und Position sprechen 
    SayFormattedMessage (OT_SCREEN_MESSAGE, msgFirstMenu_L, msgFirstMenu_S)
    SayPosition()    
    EndIf ; If giMenuStatus == cMenubarActive then
EndIf ; If iDirection == cFirst then

; wenn die Taste für "zum Ende" gedrückt wurde 
If iDirection == cLast then
    ; wenn Untermenüs geöffnet sind 
    If giMenuStatus == cSubmenuIsOpen  then
    ; zum letzten Eintrag gehen
    giSubMenuEntryPos = giSubMenuEntryMax
    ; dies melden 
    SayFormattedMessage (OT_SCREEN_MESSAGE, msgLastSubmenuEntry_L, msgLastSubmenuEntry_S)
    ; und Position sprechen 
    SayPosition()    
    EndIf ; If giMenuStatus == cSubmenuIsOpen  then

    ; wenn Menü geöffnet ist oder wir vor einem geschlossenen Untermenü stehen 
    If (giMenuStatus == cMenusOpen) || (giMenuStatus == cSubmenu ) then
    ; zum letzten Eintrag gehen 
    giMenuEntryPos = giMenuEntryMax
    ; dies melden 
    SayFormattedMessage (OT_SCREEN_MESSAGE, msgLastMenuEntry_L, msgLastMenuEntry_S)
    ; und Position sprechen 
    SayPosition()
    EndIf ; If (giMenuStatus == cMenusOpen) || (giMenuStatus == cSubmenu ) then

    ; wenn wir uns in der Menüleiste befinden 
    If giMenuStatus == cMenubarActive then
    ; zum letzten Menüeintrag gehen
    giMenuBarPos = giMenuBarMax
    ; Anzahl der Menüeinträge ermitteln 
    gsMenuEntries = GetMenuEntries (giMenuBarPos)
    ; Position der Menüeinträge auf 0 setzten (= nicht geöffnet)
    giMenuEntryPos = 0
    ; Anzahl Menüeinträge ermitteln 
    giMenuEntryMax = StringSegmentCount (gsMenuEntries, "|")
    ; Melden, dass das letzte Menü aktiviert ist 
    SayFormattedMessage (OT_SCREEN_MESSAGE, msgLastMenu_L, msgLastMenu_S)
    ; Position sprechen 
    SayPosition()    
    EndIf ; If giMenuStatus == cMenubarActive then
EndIf ; If iDirection == cLast then

; Wenn das Menü geschlossen werden soll
If iDirection == cClose then
; Wenn ein Untermenü geöffnet ist, 
; oder wenn wir uns vor einem geöffneten Untermenü befinden 
; oder wenn Menüs geöffnet sind ...
; (Anmerkung: "If giMenuStatus > 1 then" würde auch funktionieren 
; jedoch können später evtl. weitere Konstanten-Werte hinzukommen, 
; weshalb ich mich für diese Option hier entschieden habe)
    If giMenuStatus == cSubmenuIsOpen 
    || giMenuStatus == cSubmenu
    || giMenuStatus == cMenusOpen then
    ; Position der Menüleiste bleibt unverändert 
    giMenuBarPos = giMenuBarPos
    ; sicherheitshalber nochmals Menüeinträge laden 
    gsMenuEntries = GetMenuEntries (giMenuBarPos)
    ; Position ist 0 (= Menüeinträge werden nicht angezeigt)
    giMenuEntryPos = 0
    ; Anzahl Menüeinträge ermitteln 
    giMenuEntryMax = StringSegmentCount (gsMenuEntries, "|")
    ; Neuer Status ist "Menüleiste aktiv"
    giMenuStatus = cMenubarActive
    ; ankündigen, dass Menü geschlossen ist 
    SayFormattedMessage (OT_SCREEN_MESSAGE, msgClosedMenu_L, msgClosedMenu_S)
    ; aktuelle Position sprechen 
    SayPosition()
    EndIf ; If giMenuStatus ...
EndIf ; iDirection == cClose then
EndScript

globals
string gsBraille 

void Function SayBrailleEx () 
BrailleString (gsBraille)
EndFunction

void Function SayBraille (string sText)
; BrailleString (sText) 
gsBraille = sText
ScheduleFunction ("SayBrailleEx", 2)
EndFunction 

; -------------------------------------------------------------------------------------------------------
; Sprechen des aktuellen Eintrags, abhängig vom Menü-Status
; -------------------------------------------------------------------------------------------------------

void Function SayPosition()
var
string sText, 
string sShortcut

; wenn die Menüleiste aktiviert ist 
If giMenuStatus == cMenubarActive then
; aktuelles Menü anhand der Position (giMenuBarPos) ermitteln
sText = StringSegment (gsMenuBar, "|", giMenuBarPos)
; ermitteltes Menü sprechen 
SayFormattedMessage (OT_SCREEN_MESSAGE, sText, sText)
SayBraille (sText) 
Return
EndIf ; If giMenuStatus == cMenubarActive then

; wenn ein Untermenü vorhanden (jedoch noch nicht geöffnet) ist 
If giMenuStatus == cSubmenu then
; Text des Menüeintrags ermitteln 
sText = StringSegment (gsMenuEntries , "|", giMenuEntryPos)
; und sprechen 
SayFormattedMessage (OT_SCREEN_MESSAGE, sText, sText)
SayBraille (sText) 
; sShortcut ermitteln 
sShortcut = GetMenuShortcut(giMenuBarPos, giMenuEntryPos)

; Shortcut sprechen
SayFormattedMessage (OT_SCREEN_MESSAGE, sShortcut, sShortcut)
; Status sprechen (= Untermenü)
SayFormattedMessage (OT_SCREEN_MESSAGE, msgHasSubmenu_L, msgHasSubmenu_S)
; und Script verlassen 
Return
EndIf ; If giMenuStatus == cSubmenu then

; wenn das Untermenü geöffnet ist 
If giMenuStatus == cSubmenuIsOpen  then
; Text des Untermenüeintrags ermitteln 
sText = StringSegment (gsSubMenuEntries, "|", giSubMenuEntryPos)
; und sprechen 
SayFormattedMessage (OT_SCREEN_MESSAGE, sText, sText)
SayBraille (sText) 
; Shortcut ermitteln 
sShortcut = GetSubMenuShortcut(giMenuBarPos, giMenuEntryPos, giSubMenuEntryPos)
; Shortcut sprechen
SayFormattedMessage (OT_SCREEN_MESSAGE, sShortcut, sShortcut)
EndIf ;  If giMenuStatus == cSubmenuIsOpen  then
 
; wenn das Menü geöffnet ist 
If giMenuStatus == cMenusOpen then
; Text des Menüeintrags ermitteln 
sText = StringSegment (gsMenuEntries , "|", giMenuEntryPos)
; und sprechen 
SayFormattedMessage (OT_SCREEN_MESSAGE, sText, sText)
SayBraille (sText) 

; Shortcut ermitteln 
sShortcut = GetMenuShortcut(giMenuBarPos, giMenuEntryPos)
; Shortcut sprechen
SayFormattedMessage (OT_SCREEN_MESSAGE, sShortcut, sShortcut)
      ; wenn im Menüeintrag der Befehl "submenu" existiert, 
      If GetMenuCommand(giMenuBarPos, giMenuEntryPos) == "submenu" then
      ; sprechen, dass ein Untermenü vorhanden ist 
      SayFormattedMessage (OT_SCREEN_MESSAGE, msgHasSubmenu_L, msgHasSubmenu_S)
      
      ; Status speichern 
      giMenuStatus = cSubmenu
      EndIf ; If GetMenuCommand(giMenuBarPos, giMenuEntryPos) == "submenu" then
; Funkction verlassen  
Return
EndIf ; If giMenuStatus == cMenusOpen then
EndFunction

; -------------------------------------------------------------------------------------------------------
; Ausführen der Befehle nach Drücken von Enter 
; -------------------------------------------------------------------------------------------------------

Script SelectCommand()
; Die diesem Script zugewiesene Taste beendet die gestaffelten Tasten 
; auf jeden Fall. Entweder wird der Menübefehl ausgeführt oder aber 
; die Enter-Taste wird an der falschen Stelle gedrückt (z. B. in der 
; Menüleiste). 

; Aus diesem Grund wird vorab geprüft, ob dies der Fall ist. Falls ja, 
; wird das Script zum Beenden der gestaffelten Tasten (ExitMenuLayer) 
; ausgeführt und das Script (SelectCommand) vorzeitig beendet

; Wenn wir uns in der Menüleiste oder vor einem Untermenü befinden 
If (giMenuStatus == cMenubarActive) || (giMenuStatus == cSubmenu) then
; vorab die Meldung, dass kein Menübefehl ausgewählt wurde 
SayFormattedMessage (OT_SCREEN_MESSAGE, msgCloseWithEnter_L, msgCloseWithEnter_S)
; Standardscript zum Beenden aufrufen 
PerformScript ExitMenuLayer()
; Script verlassen 
Return
EndIf ; If (giMenuStatus == cMenubarActive) || (giMenuStatus == cSubmenu) then

; ab hier wird das Script nicht mehr vorzeitig beendet und 
; die Standard-Funktion zum Ermitteln und Ausführen der 
; Befehle gestartet: 

var
string sCommand, 
string sParam,
string sShortcut

; wenn die Menüs geöffnet sind 
If giMenuStatus == cMenusOpen then
; Shortcut ermitteln (wird nicht gebraucht, deshalb deaktiviert)
; sShortcut = GetMenuShortcut(giMenuBarPos, giMenuEntryPos)
; Befehlszeile aus der XML-Datei ermitteln (Menüeintrag)
sCommand = GetMenuCommand(giMenuBarPos, giMenuEntryPos)
; die Parameter zur Befehlszeile ermitteln 
sParam = GetMenuParam(giMenuBarPos, giMenuEntryPos)
EndIf ; If giMenuStatus == cMenubarActive then

; Wenn ein Untermenü geöffnet ist 
If giMenuStatus == cSubmenuIsOpen then
; Shortcut ermitteln (wird nicht gebraucht, deshalb deaktiviert)
; sShortcut = GetSubMenuShortcut(giMenuBarPos, giMenuEntryPos)
; Befehlszeile aus der XML-Datei ermitteln (Untermenüeintrag)
sCommand = GetSubMenuCommand(giMenuBarPos, giMenuEntryPos, giSubMenuEntryPos)
; die Parameter zur Befehlszeile ermitteln 
sParam = GetSubMenuParam(giMenuBarPos, giMenuEntryPos, giSubMenuEntryPos)
EndIf ; If giMenuStatus == cSubmenuIsOpen then

var
; Zum Ausführen von Word-Makros COM-Verbindung zu Word aufbauen 
object oWinword = GetObject ("Word.Application"), 
; Strings zur Parameterübergabe an Funktionen und Scripts 
string s0, string s1, string s2, string s3, string s4, string s5, string s6, string s7, string s8, string s9

; wenn der Befehl "mail" lautet , dann 
If sCommand == "mail" then
; über Run-Fuktion E-Mail starten 
Run ("mailto:" + sParam)
EndIf ; If sCommand == "mail" then

; wenn der Befehl "mouseclick" lautet , dann 
If sCommand == "mouseclick" then
; an Position x (erstes Segment von sParam) und y (zweites Segmehnt von sParam) 
; mit der Maus klicken 
ClickAtPoint (StringToInt (StringSegment (sParam, "|", 1)), StringToInt(StringSegment (sParam, "|", 2)))

; SaveCursor ()
; JAWSCursor ()
; MoveTo (StringToInt (StringSegment (sParam, "|", 1)), StringToInt(StringSegment (sParam, "|", 2)))
; LeftMouseButton ()
; RestoreCursor ()
EndIf ; If sCommand == "mouseclick" then

; wenn der Befehl "explorer" ist, dann 
If sCommand == "explorer" then
; Explorer starten mit dem Parameter in sParam 
Run ("Explorer.exe "+sParam)
EndIf ; If sCommand == "explorer" then

; wenn der Befehl "internet" lautet, dann 
If sCommand == "internet" then
; Web-Adresse (sParam) über Run-Funktion starten 
Run (sParam)
EndIf ; If sCommand == "internet" then

; wenn der Befehl "function" lautet, dann 
If sCommand == "function" then
; wenn Kein Parameter (senkrechter Strich in sParam) mitgegeben wurde 
If StringSegmentCount (sParam, "|") == 1 then
; JAWS-Funktion ohne Parameter starten 
CallFunctionByName (sParam)
EndIf ; If StringSegmentCount (sParam, "|") == 1 then

; ab hier Anzahl Parameter ermitteln und abhängig davon 
; JAWS-Funktion mit den Parametern starten 

If StringSegmentCount (sParam, "|") == 2 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
CallFunctionByName (s0, s1)
EndIf ; If StringSegmentCount (sParam, "|") == 2 then

If StringSegmentCount (sParam, "|") == 3 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
CallFunctionByName (s0, s1, s2)
EndIf ; If StringSegmentCount (sParam, "|") == 3 then

If StringSegmentCount (sParam, "|") == 4 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
CallFunctionByName (s0, s1, s2, s3)
EndIf ; If StringSegmentCount (sParam, "|") == 4 then 

If StringSegmentCount (sParam, "|") == 5 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
CallFunctionByName (s0, s1, s2, s3, s4)
EndIf ; If StringSegmentCount (sParam, "|") == 5 then

If StringSegmentCount (sParam, "|") == 6 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
s5 = StringSegment (sParam, "|", 6)
CallFunctionByName (s0, s1, s2, s3, s4, s5)
EndIf ; If StringSegmentCount (sParam, "|") == 6 then

If StringSegmentCount (sParam, "|") == 7 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
s5 = StringSegment (sParam, "|", 6)
s6 = StringSegment (sParam, "|", 7)
CallFunctionByName (s0, s1, s2, s3, s4, s5, s6)
EndIf ; If StringSegmentCount (sParam, "|") == 7 then

If StringSegmentCount (sParam, "|") == 8 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
s5 = StringSegment (sParam, "|", 6)
s6 = StringSegment (sParam, "|", 7)
s7 = StringSegment (sParam, "|", 8)
CallFunctionByName (s0, s1, s2, s3, s4, s5, s6, s7)
EndIf ; If StringSegmentCount (sParam, "|") == 8 then

If StringSegmentCount (sParam, "|") == 9 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
s5 = StringSegment (sParam, "|", 6)
s6 = StringSegment (sParam, "|", 7)
s7 = StringSegment (sParam, "|", 8)
s8 = StringSegment (sParam, "|", 9)
CallFunctionByName (s0, s1, s2, s3, s4, s5, s6, s7, s8)
EndIf ; If StringSegmentCount (sParam, "|") == 9 then

If StringSegmentCount (sParam, "|") == 10 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
s5 = StringSegment (sParam, "|", 6)
s6 = StringSegment (sParam, "|", 7)
s7 = StringSegment (sParam, "|", 8)
s8 = StringSegment (sParam, "|", 9)
s9 = StringSegment (sParam, "|", 10)
CallFunctionByName (s0, s1, s2, s3, s4, s5, s6, s7, s8, s9)
EndIf ; If StringSegmentCount (sParam, "|") == 10 then

EndIf ; If sCommand == "function" then

; wenn der Befehl "script" lautet dann 
If sCommand == "script" then

; wenn kein Parameter (senkrechter Strich in sParam) mitgegeben wurde 
If StringSegmentCount (sParam, "|") == 1 then
; JAWS-Script ohne Parameter starten 
PerformScriptByName (sParam)
EndIf ; If StringSegmentCount (sParam, "|") == 1 then

; ab hier Anzahl Parameter ermitteln und abhängig davon 
; JAWS-Script mit den Parametern starten 

If StringSegmentCount (sParam, "|") == 2 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
PerformScriptByName (s0, s1)
EndIf ; If StringSegmentCount (sParam, "|") == 2 then

If StringSegmentCount (sParam, "|") == 3 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
PerformScriptByName (s0, s1, s2)
EndIf ; If StringSegmentCount (sParam, "|") == 3 then

If StringSegmentCount (sParam, "|") == 4 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
PerformScriptByName (s0, s1, s2, s3)
EndIf ; If StringSegmentCount (sParam, "|") == 4 then

If StringSegmentCount (sParam, "|") == 5 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
PerformScriptByName (s0, s1, s2, s3, s4)
EndIf ; If StringSegmentCount (sParam, "|") == 5 then

If StringSegmentCount (sParam, "|") == 6 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
s5 = StringSegment (sParam, "|", 6)
PerformScriptByName (s0, s1, s2, s3, s4, s5)
EndIf ; If StringSegmentCount (sParam, "|") == 6 then

If StringSegmentCount (sParam, "|") == 7 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
s5 = StringSegment (sParam, "|", 6)
s6 = StringSegment (sParam, "|", 7)
PerformScriptByName (s0, s1, s2, s3, s4, s5, s6)
EndIf ; If StringSegmentCount (sParam, "|") == 7 then

If StringSegmentCount (sParam, "|") == 8 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
s5 = StringSegment (sParam, "|", 6)
s6 = StringSegment (sParam, "|", 7)
s7 = StringSegment (sParam, "|", 8)
PerformScriptByName (s0, s1, s2, s3, s4, s5, s6, s7)
EndIf ; If StringSegmentCount (sParam, "|") == 8 then

If StringSegmentCount (sParam, "|") == 9 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
s5 = StringSegment (sParam, "|", 6)
s6 = StringSegment (sParam, "|", 7)
s7 = StringSegment (sParam, "|", 8)
s8 = StringSegment (sParam, "|", 9)
PerformScriptByName (s0, s1, s2, s3, s4, s5, s6, s7, s8)
EndIf ; If StringSegmentCount (sParam, "|") == 9 then

If StringSegmentCount (sParam, "|") == 10 then
s0 = StringSegment (sParam, "|", 1)
s1 = StringSegment (sParam, "|", 2)
s2 = StringSegment (sParam, "|", 3)
s3 = StringSegment (sParam, "|", 4)
s4 = StringSegment (sParam, "|", 5)
s5 = StringSegment (sParam, "|", 6)
s6 = StringSegment (sParam, "|", 7)
s7 = StringSegment (sParam, "|", 8)
s8 = StringSegment (sParam, "|", 9)
s9 = StringSegment (sParam, "|", 10)
PerformScriptByName (s0, s1, s2, s3, s4, s5, s6, s7, s8, s9)
EndIf ; If StringSegmentCount (sParam, "|") == 10 then

EndIf ; If sCommand == "script" then

; wenn der Befehl "notepad" lautet, dann 
If sCommand == "notepad" then
; den Windows-Editor mit den Parametern in sParam starten 
Run ("Notepad.exe "+sParam)
EndIf ; If sCommand == "notepad" then

; wenn der Befehl "run" ist, dann 
If sCommand == "run" then
; Programm/Datei mit den in sParam angegebenen Parametern starten 
Run (sParam)
EndIf ; If sCommand == "run" then

; wenn der Befehl "wordmacro" lautet, dann 
If sCommand == "wordmacro" then
; Word-Makro starten 
oWinword.run(sParam)
EndIf ; If sCommand == "wordmacro" then

; wenn der Befehl "worddialog" lautet, dann 
If sCommand == "worddialog" then
; Hinweis sprechen auf Verzögerung von Dialogen durch Word
SayFormattedMessage (OT_SCREEN_MESSAGE, msgWordDialog_L, msgWordDialog_S)
; Dialog starten
oWinword.Dialogs(sParam).Show
EndIf ; If sCommand == "worddialog" then

; Com-Verbindung lösen 
oWinword = Null ()

; Am Ende Script zum Beenden der gestaffelten Tasten ausführen 
PerformScript ExitMenuLayer()
EndScript

; -------------------------------------------------------------------------------------------------------
; Kurztasten
; -------------------------------------------------------------------------------------------------------

Script FindChar(string sChar)
var
int i,
int iPos, 
string sHotkey

; Wenn die Menüs noch nicht aktiviert sind 
If !giMenus then
; auch keinen Hotkey verwenden, als Hinweis Sound spielen 
PlaySound(FindJAWSSoundFile (cNoHotkey, False))
Return 
EndIf ; If !giMenus then

; Wenn wir in der Menüleiste sind 
If giMenuStatus == cMenubarActive then
      ; Schleife über alle Elemente der Menüleiste 
      for i = 1  to giMenuBarMax
      ; zur aktuellen Position 1 hinzu, da ab nächstem Punkt gesucht werden soll
      iPos = i + giMenuBarPos
            ; Wenn die aktuelle Position über die Anzahl der Menüs hinausgeht 
            if iPos > giMenuBarMax then
            ; die Position vom Maximalwert der Einträge abziehen 
            iPos = iPos - giMenuBarMax
            EndIf ; if iPos > giMenuBarMax then
      ; Zuerst kompletten Menüeintrag laden 
      sHotKey = StringSegment (gsMenuBar, "|", iPos)
      ; dann den ersten Buchstaben 
      sHotKey = StringLeft (sHotkey, 1)
            ; Vergleich in Kleinbuchstaben, ob der aktuelle Wert dem gesuchten Wert entspricht
            If StringLower(sHotKey) == StringLower(sChar) then
            ; Wenn ja, dann aktuelle Position merken 
            giMenuBarPos = iPos
            ; Menüeinträge laden 
            gsMenuEntries = GetMenuEntries (giMenuBarPos)
            ; da noch nicht aufgeklappt, Position auf 0 stellen 
            giMenuEntryPos = 0
            ; Maximalwert der Menüeinträge ermitteln 
            giMenuEntryMax = StringSegmentCount (gsMenuEntries, "|")
            ; Aktuellen Eintrag sprechen 
            SayPosition()
            ; Da gefunden, hier Funktion verlassen 
            Return
            EndIf ; If StringLower(sHotKey) == StringLower(sChar) then
      Endfor ; for i = 1  to giMenuBarMax

; Wurde die Funktion bis hierher nicht vorzeitig verlassen
; dann wurde kein Hotkey gefunden, Sound als Hinweis abspielen 
PlaySound(FindJAWSSoundFile (cNoHotkey, False))
EndIf ; If giMenuStatus == cMenubarActive then

; Wenn ein Menü geöffnet ist oder ein Untermenü angekündigt wird, dann 
If (giMenuStatus) == cMenusOpen || (giMenuStatus == cSubmenu) then
      ; Untermenü-Status ausschalten. 
      ; Sollte die Suche auf einem Untermenü landen, wird der 
      ; Status (Untermenü) neu gesetzt. Sollte hingegen der Fokus bereits 
      ; vor der Suche auf einem  Untermenü sein, würde das dazu führen, 
      ; dass der neu gefundene Eintrag fälschlicherweise als Untermenü 
      ; gekennzeichnet ist, deshalb:
      ; merken, dass keine Untermenüs vorhanden sind 
      giMenuStatus = cMenusOpen 
      ; Schleife über alle Elemente der Menüeinträge
      for i = 1  to giMenuEntryMax
      ; zur aktuellen Position 1 hinzu, da ab nächstem Punkt gesucht werden soll
      iPos = i + giMenuEntryPos
            ; Wenn die aktuelle Position über die Anzahl der Menüpunkte hinausgeht 
            if iPos > giMenuEntryMax then
            ; die Position vom Maximalwert der Einträge abziehen 
            iPos = iPos - giMenuEntryMax
            EndIf ; if iPos > giMenuEntryMax then
      ; Zuerst kompletten Menüeintrag laden 
      sHotKey = StringSegment (gsMenuEntries, "|", iPos)
      ; dann den ersten Buchstaben 
      sHotKey = StringLeft (sHotkey, 1)
            ; Vergleich in Kleinbuchstaben, ob der aktuelle Wert dem gesuchten Wert entspricht
            If StringLower(sHotKey) == StringLower(sChar) then
            ; Wenn ja, dann aktuelle Position merken 
            giMenuEntryPos = iPos
            ; Aktuellen Eintrag sprechen 
            SayPosition()
            ; Da gefunden, hier Funktion verlassen 
            Return
            EndIf ; If StringLower(sHotKey) == StringLower(sChar) then
      Endfor ; for i = 1  to giMenuEntryMax

; Wurde die Funktion bis hierher nicht vorzeitig verlassen
; dann wurde kein Hotkey gefunden, Sound als Hinweis abspielen 
PlaySound(FindJAWSSoundFile (cNoHotkey, False))
EndIf ; If giMenuStatus == cMenusOpen then

; wenn ein Untermenü geöffnet ist 
If giMenuStatus == cSubmenuIsOpen then
      ; Schleife über alle Elemente der Untermenüeinträge
      for i = 1  to giSubMenuEntryMax
      ; zur aktuellen Position 1 hinzu, da ab nächstem Punkt gesucht werden soll
      iPos = i + giSubMenuEntryPos
            ; Wenn die aktuelle Position über die Anzahl der Menüpunkte hinausgeht 
            if iPos > giSubMenuEntryMax then
            ; die Position vom Maximalwert der Einträge abziehen 
            iPos = iPos - giSubMenuEntryMax
            EndIf ; if iPos > giSubMenuEntryMax then
      ; Zuerst kompletten Menüeintrag laden 
      sHotKey = StringSegment (gsSubMenuEntries, "|", iPos)
      ; dann den ersten Buchstaben 
      sHotKey = StringLeft (sHotkey, 1)
            ; Vergleich in Kleinbuchstaben, ob der aktuelle Wert dem gesuchten Wert entspricht
            If StringLower(sHotKey) == StringLower(sChar) then
            ; Wenn ja, dann aktuelle Position merken 
            giSubMenuEntryPos = iPos
            ; Aktuellen Eintrag sprechen 
            SayPosition()
            ; Da gefunden, hier Funktion verlassen 
            Return
            EndIf ; If StringLower(sHotKey) == StringLower(sChar) then
      Endfor ; for i = 1  to giSubMenuEntryMax

; Wurde die Funktion bis hierher nicht vorzeitig verlassen
; dann wurde kein Hotkey gefunden, Sound als Hinweis abspielen 
PlaySound(FindJAWSSoundFile (cNoHotkey, False))
EndIf ; If giMenuStatus == cSubmenuIsOpen then

EndScript


; xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
; Beispiel-Menüs
; xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

; -------------------------------------------------------------------------------------------------------
; klassische Word-Menüs
; -------------------------------------------------------------------------------------------------------

void Function WordMenu()
CreateMenu ("Datei")
  CreateMenuEntry ("Neu...", "Strg+N", "wordmacro", "FileNew")
  CreateMenuEntry ("Öffnen...", "Strg+O", "wordmacro", "FileOpen")
  CreateMenuEntry ("Schließen", "Strg+F4", "wordmacro", "FileClose")
  CreateMenuEntry ("Speichern", "Strg+S", "wordmacro", "FileSave")
  CreateMenuEntry ("Speichern unter...", "F12", "wordmacro", "FileSaveAs")
  CreateMenuEntry ("Als Webseite speichern...", "", "wordmacro", "FileSaveAsWebPage")
  CreateMenuEntry ("Webseitenvorschau", "", "wordmacro", "WebPagePreview")
  CreateMenuEntry ("Seite einrichten...", "", "wordmacro", "FilePageSetup")
  CreateMenuEntry ("Seitenansicht", "Strg+F2", "wordmacro", "FilePrintPreview")
  CreateMenuEntry ("Drucken...", "Strg+P", "wordmacro", "FilePrint")
  CreateMenuEntry ("Senden an Mailempfänger", "", "wordmacro", "FileSendMail")
  CreateMenuEntry ("Eigenschaften...", "", "wordmacro", "FileProperties")
  CreateMenuEntry ("Beenden", "Alt+F4", "wordmacro", "FileExit")

CreateMenu ("Bearbeiten")
  CreateMenuEntry ("Rückgängig", "Strg+Z", "wordmacro", "EditUndo")
  CreateMenuEntry ("Wiederholen", "Strg+Y", "wordmacro", "EditRedoOrRepeat")
  CreateMenuEntry ("Ausschneiden", "Strg+X", "wordmacro", "EditCut")
  CreateMenuEntry ("Kopieren", "Strg+C", "wordmacro", "EditCopy")
  CreateMenuEntry ("Einfügen", "Strg+V", "wordmacro", "EditPaste")
  CreateMenuEntry ("Inhalte einfügen...", "Strg+Alt+V", "wordmacro", "EditPasteSpecial")
  CreateMenuEntry ("Als Hyperlink einfügen", "", "wordmacro", "EditPasteAsHyperlink")
  CreateMenuEntry ("Markierung löschen", "Entf", "wordmacro", "EditClear")
  CreateMenuEntry ("Alles markieren", "Strg+A", "wordmacro", "EditSelectAll")
  CreateMenuEntry ("Suchen...", "Strg+F", "wordmacro", "EditFind")
  CreateMenuEntry ("Ersetzen...", "Strg+H", "wordmacro", "EditReplace")
  CreateMenuEntry ("Gehe zu...", "Strg+G", "wordmacro", "EditGoTo")

CreateMenu ("Ansicht")
  CreateMenuEntry ("Normal", "Strg+Alt+N", "wordmacro", "ViewNormal")
  CreateMenuEntry ("Weblayout", "", "wordmacro", "ViewWeb")
  CreateMenuEntry ("Seitenlayout", "", "wordmacro", "ViewPage")
  CreateMenuEntry ("Gliederung", "", "wordmacro", "ViewOutline")
  CreateMenuEntry ("Lineal", "", "wordmacro", "ViewRuler")
  CreateMenuEntry ("Dokumentstruktur", "", "wordmacro", "ViewDocumentMap")
  CreateMenuEntry ("Kopf- und Fußzeile", "", "wordmacro", "ViewHeader")
  CreateMenuEntry ("Fußnoten", "", "wordmacro", "ViewFootnotes")
  CreateMenuEntry ("Kommentare", "", "wordmacro", "ViewAnnotations")
  CreateMenuEntry ("Zoom...", "", "wordmacro", "ViewZoom")  

CreateMenu ("Einfügen")
  CreateMenuEntry ("AutoText...", "", "wordmacro", "AutoText")
  CreateMenuEntry ("AutoText Neu...", "Alt+F3", "wordmacro", "CreateAutoText")
  CreateMenuEntry ("Seitenzahlen...", "", "wordmacro", "EinfügenSeitenzahl")
  CreateMenuEntry ("Feld...", "", "wordmacro", "InsertField")
  CreateMenuEntry ("Symbol...", "", "wordmacro", "InsertSymbol")
  CreateMenuEntry ("Kommentar", "", "wordmacro", "InsertAnnotation")
  CreateMenuEntry ("Fußnote...", "", "wordmacro", "InsertFootnote")
  CreateMenuEntry ("Beschriftung...", "", "wordmacro", "InsertCaption")
  CreateMenuEntry ("Querverweis...", "", "wordmacro", "InsertCrossReference")
  CreateMenuEntry ("Index und Verzeichnisse...", "", "wordmacro", "InsertIndexAndTables")
  CreateMenuEntry ("Grafik", "", "submenu", "")
     CreateSubMenuEntry("aus Datei...", "", "wordmacro", "InsertPicture")
     CreateSubMenuEntry("WordArt...", "", "wordmacro", "InsertWordArt")
     CreateSubMenuEntry("von Scanner oder Kamera...", "", "wordmacro", "InsertImagerScan")
  CreateMenuEntry ("Diagramm", "", "wordmacro", "InsertChart")
  CreateMenuEntry ("Textfeld", "", "wordmacro", "InsertFrame")
  CreateMenuEntry ("Datei...", "", "wordmacro", "InsertFile")
  CreateMenuEntry ("Objekt...", "", "wordmacro", "InsertObject")
  CreateMenuEntry ("Textmarke...", "", "wordmacro", "EditBookmark")
  CreateMenuEntry ("Hyperlink...", "Strg+K", "wordmacro", "InsertHyperlink")
  CreateMenuEntry ("Manueller Wechsel...", "", "wordmacro", "InsertBreak")

CreateMenu ("Format")
  CreateMenuEntry ("Zeichen...", "Strg+D", "wordmacro", "FormatFont")
  CreateMenuEntry ("Absatz...", "", "wordmacro", "FormatParagraph")
  CreateMenuEntry ("Nummerierung und Aufzählungszeichen...", "", "wordmacro", "FormatBulletsAndNumbering")
  CreateMenuEntry ("Rahmen und Schattierung...", "", "wordmacro", "FormatBordersAndShading")
  CreateMenuEntry ("Spalten...", "", "wordmacro", "FormatColumns")
  CreateMenuEntry ("Tabstopp...", "", "wordmacro", "FormatTabs")
  CreateMenuEntry ("Initial...", "", "wordmacro", "FormatDropCap")
  CreateMenuEntry ("Absatzrichtung...", "", "wordmacro", "FormatTextFlow")
  CreateMenuEntry ("Groß-/Kleinschreibung...", "", "wordmacro", "FormatChangeCase")
  CreateMenuEntry ("Hintergrund (Fülleffekte", "", "wordmacro", "FormatBackgroundFillEffect")
  CreateMenuEntry ("Formatvorlage...", "", "wordmacro", "FormatStyle")

CreateMenu ("Extras")
  CreateMenuEntry ("Rechtschreibung und Grammatik...", "F7", "wordmacro", "ToolsProofing")
  CreateMenuEntry ("Sprache", "", "submenu", "")
     CreateSubMenuEntry ("Sprache bestimmen...", "", "wordmacro", "ToolsLanguage")
     CreateSubMenuEntry ("Thesaurus...)", "Umschalt+F7", "wordmacro", "ToolsThesaurus")
     CreateSubMenuEntry ("Silbentrennung...", "",  "wordmacro", "ToolsHyphenation")
  CreateMenuEntry ("Wörter zählen...", "", "wordmacro", "ToolsWordCount")
  CreateMenuEntry ("AutoKorrektur...", "", "worddialog", "915")
  CreateMenuEntry ("Änderungen nachverfolgen", "", "submenu", "")
    CreateSubMenuEntry ("Änderungen hervorheben...", "", "worddialog", "197")
    CreateSubMenuEntry ("Änderungen akzeptieren oder ablehnen...", "", "worddialog", "506")
    CreateSubMenuEntry ("Dokumente zusammenführen...", "", "wordmacro", "ToolsMergeRevisions")
  CreateMenuEntry ("Dokument schützen...", "", "wordmacro", "ToolsProtectDocument")
  CreateMenuEntry ("Seriendruck...", "", "worddialog", "680")
  CreateMenuEntry ("Umschläge und Etiketten...", "", "worddialog", "173")
  CreateMenuEntry ("Brief-Assistent...", "", "wordmacro", "LetterWizard")
  CreateMenuEntry ("Makro", "", "submenu", "")
    CreateSubMenuEntry ("Makros...", "Alt+F8", "wordmacro", "ToolsMacro")
    CreateSubMenuEntry ("Sicherheit...",  "", "wordmacro", "ViewSecurity")
    CreateSubMenuEntry ("Visual Basic-Editor", "Alt+F11", "wordmacro", "ViewVBCode")
  CreateMenuEntry ("Vorlagen und Add-Ins...", "", "worddialog", "222")
  CreateMenuEntry ("Anpassen", "", "worddialog", "432")
  CreateMenuEntry ("Optionen...", "", "worddialog", "974")

CreateMenu ("Tabelle")
  CreateMenuEntry ("Zellen einfügen", "", "submenu", "")
    CreateSubMenuEntry ("Tabelle", "", "wordmacro", "TableInsertTable")
    CreateSubMenuEntry ("Spalten nach links", "", "wordmacro", "TableInsertColumn")
    CreateSubMenuEntry ("Zellen einfügen: Spalten nach rechts", "", "wordmacro", "TableInsertColumnRight")
    CreateSubMenuEntry ("Zellen einfügen: Zeilen oberhalb", "", "wordmacro", "TableInsertRowAbove")
    CreateSubMenuEntry ("Zellen einfügen: Zeilen unterhalb", "", "wordmacro", "TableInsertRowBelow")
    CreateSubMenuEntry ("Zellen einfügen: Zellen...", "", "wordmacro", "TableInsertCells")
  CreateMenuEntry ("Löschen", "", "submenu", "")
    CreateSubMenuEntry ("Tabelle", "", "wordmacro", "TableDeleteTable")
    CreateSubMenuEntry ("Spalten", "", "wordmacro", "TableDeleteColumn")
    CreateSubMenuEntry ("Zeilen", "", "wordmacro", "TableDeleteRow")
    CreateSubMenuEntry ("Zellen", "", "wordmacro", "TableDeleteCells")
  CreateMenuEntry ("Markieren", "", "submenu", "")
    CreateSubMenuEntry ("Tabelle", "", "wordmacro", "TableSelectTable")
    CreateSubMenuEntry ("Spalte", "", "wordmacro", "TableSelectColumn")
    CreateSubMenuEntry ("Zeile", "", "wordmacro", "TableSelectRow")
    CreateSubMenuEntry ("Zelle", "", "wordmacro", "TableSelectCell")
  CreateMenuEntry ("Zellen", "", "submenu", "")
    CreateSubMenuEntry ("Zellen verbinden", "", "wordmacro", "TableMergeCells")
    CreateSubMenuEntry ("Zellen teilen...", "", "wordmacro", "TableSplitCells")
  CreateMenuEntry ("Tabelle teilen", "", "wordmacro", "TableSplit")
  CreateMenuEntry ("Tabelle AutoFormat...", "", "wordmacro", "TableAutoFormat")
  CreateMenuEntry ("AutoAnpassen", "", "submenu", "")
    CreateSubMenuEntry ("Inhalt", "", "wordmacro", "AutoFitContent")
    CreateSubMenuEntry ("Fenster", "", "wordmacro", "AutoFitWindow")
    CreateSubMenuEntry ("Feste Spaltenbreite", "", "wordmacro", "AutoFitFixed")
    CreateSubMenuEntry ("Zeilen gleichmäßig verteilen", "", "wordmacro", "DistributeRow")
    CreateSubMenuEntry ("Spalten gleichmäßig verteilen", "", "wordmacro", "DistributeColumn")
  CreateMenuEntry ("Umwandeln ", "", "submenu", "")
    CreateSubMenuEntry ("Text in Tabelle...", "", "wordmacro", "TextToTable")
    CreateSubMenuEntry ("Tabelle in Text...", "", "wordmacro", "TableToText")
  CreateMenuEntry ("Sortieren...", "", "wordmacro", "TableSort")
  CreateMenuEntry ("Formel...", "", "wordmacro", "TableFormula")
  CreateMenuEntry ("Gitternetzlinien aus- bzw. einblenden", "", "wordmacro", "TableGridlines")
  CreateMenuEntry ("Tabelleneigenschaften...", "", "wordmacro", "TableProperties")

EndFunction


Script StartWordMenu()
NewXMLMenu ("Klassische Word Menüs")
; ClearXML ()
WordMenu()
StartMenuLayer()
EndScript

; -------------------------------------------------------------------------------------------------------
; Steuerelemente einer Anwendung als Menü auflisten 
; -------------------------------------------------------------------------------------------------------


; ----------------------------------------------------------------------------------------------
; Ausführen des gewählten Controls (in einer bestimmten Liste)
; ----------------------------------------------------------------------------------------------

Script ControlTypeMenuStart (int iNumber, int iType)
var
object oUIA, 
object oElements, 
object oCondition, 
object oEntry, 
object oResult, 
int iResult,
int x, 
int y,
string sName,
int i
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
If DialogActive () then
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
else
oElements = oUIA.GetElementFromHandle (GetAppMainWindow(GetFocus())).BuildUpdatedCache()
EndIf ; If DialogActive () then
If !oElements then
Return 
EndIf 
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, iType)
If !oCondition then Return EndIf 
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
If oElements.Count < 1 then Return  EndIf 
i = 0
ForEach oEntry in oElements
i = i + 1
      if i == iNumber then 
      oResult = oEntry
      EndIf 
EndForEach 

sName = oResult.Name 

; Wenn man das Steuerelement fokussieren kann 
If oResult.IsKeyboardFocusable  then
; Fokus setzen 
iResult = oResult.SetFocus() 
if iResult then 
SayFormattedMessage (OT_SCREEN_MESSAGE, msgSetFocus_L, msgSetFocus_S, sName)
Return 
EndIf 
endIf 

; als nächstes Versuchen, Objekt auszuführen 
iResult = oResult.GetInvokePattern().Invoke 
If iResult then
SayFormattedMessage (OT_SCREEN_MESSAGE, msgInvokeObject_L, msgInvokeObject_S, sName)
Return
EndIf 

; als letzte Möglichkeit versuchen, das Objekt anzuklicken
oResult.GetClickablePoint(IntRef(x), IntRef(y))

If !(x == 0) && !(y == 0) then 
ClickAtPoint (x, y) 
SayFormattedMessage (OT_SCREEN_MESSAGE, msgClickObject_L, msgClickObject_S, sName)
else
SayFormattedMessage (OT_SCREEN_MESSAGE, msgAllFailedObject_L, msgAllFailedObject_S, sName)
EndIf ; If !(x == 0) && (y == 0) then 
EndScript

; ----------------------------------------------------------------------------------------------
; Control-Sammlung zu einem Menü hinzufügen 
; ----------------------------------------------------------------------------------------------

void Function AddControlToControlTypeMenu (int iUIAControlType)
var
object oUIA, 
object oElements, 
object oCondition, 
object oEntry,
string sTemp,
string sName,
int bAdd,
int i,
int iCount,
int iControl, 
int bListCreated

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )

If DialogActive () then
oElements = oUIA.GetElementFromHandle (GetRealWindow(GetFocus())).BuildUpdatedCache()
else
oElements = oUIA.GetElementFromHandle (GetAppMainWindow(GetFocus())).BuildUpdatedCache()
EndIf ; If DialogActive () then

If !oElements then Return EndIf 
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, iUIAControlType)
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
If oElements.Count > 0 && oElements.Count < 100 then

i = 0
iControl = 0
bListCreated = False 

ForEach oEntry in oElements
; Standardmäßig das Control zur Liste hinzufügen 
bAdd = True
i = i + 1
sName = oEntry.Name 
      ; Wenn das Control keinen Namen besitzt 
      if sName == "" then 
      ; Nummer für dieses Control erhöhten 
      iControl = iControl + 1
      sTemp = oEntry.LocalizedControlType
      ; und das Wort "Unbeschriftet" mit der Nummer ergänzen
      sName = sTemp + cElementIsUnnamed + IntToString (iControl) 
      bAdd = True 
      EndIf ; if sName == "" then

      ; Unerwünschte Controls hier herausfiltern 

      for iCount = 1 to StringSegmentCount (cUnwantedNamesComplete, "|")
            If sName == StringSegment (cUnwantedNamesComplete, "|", iCount) then
            bAdd = False
            EndIf ; If sName == StringSegment (cUnwantedNamesComplete, "|", iCount) then
      EndFor
      for iCount = 1 to StringSegmentCount (cUnwantedNamesPart, "|")
            If StringContains (sName, StringSegment (cUnwantedNamesPart, "|", iCount) ) then
            bAdd = False
            EndIf ; If StringContains (sName, StringSegment (cUnwantedNamesPart, "|", iCount) ) then
      EndFor

      ; zum Namen den Hinweis hinzufügen, falls ein Control deaktiviert ist 
      If !oEntry.IsEnabled then
      sName = sName + cElementIsDeactivated
      sName = sName + " deaktiviert "
      EndIf ; If !oEntry.IsEnabled then

      ; wenn das aktuelle Controll zur Liste hinzugefügt werden soll
      If bAdd then
            ; Liste erst erstellen, wenn der erste Eintrag hinzugefügt wird 
            ; (andernfalls kann es durch vorhergehendes Verwenden von 
            ; bAdd == false dazu kommen, dass leere Listen entstehen)
            If bListCreated == False then
            sTemp = oEntry.LocalizedControlType
            CreateMenu (sTemp)
            ; und natürlich merken, dass bereits eine Liste existiert 
            bListCreated = True 
            EndIf ; If bListCreated == False then
            CreateMenuEntry  (sName, "", "script", "ControlTypeMenuStart|"+IntToString(i)+"|"+IntToString(iUIAControlType))
      EndIf ; If bAdd then
EndForEach
EndIf ; If oElements.Count > 0 && oElements.Count < 100 then

EndFunction 

; ----------------------------------------------------------------------------------------------
; Script zum Starten des Menüs
; ----------------------------------------------------------------------------------------------

 Script StartControlsMenu ()
var
int i,
int iSkip 

if giMenus then
PerformScript FindChar(GetCurrentScriptKeyName ())
Return
EndIf 

NewXMLMenu ("Steuerelemente der Anwendung")

SayFormattedMessage (OT_SCREEN_MESSAGE, msgWaiting_L, msgWaiting_S)

; Schleife über alle UIA-ControlType-Konstanten 
for i=50000 to 50040
iSkip = False 
; diverse Controls nicht hinzufügen (iSkip = True)
If i == UIA_CalendarControlTypeId  then iSkip = True EndIf 
if i == UIA_ImageControlTypeId then iSkip = True EndIf 
if i == UIA_ListItemControlTypeId then iSkip = True EndIf 
If i == UIA_MenuControlTypeId then iSkip = True EndIf 
If i == UIA_ProgressBarControlTypeId then iSkip = True EndIf 
If i == UIA_ScrollBarControlTypeId then iSkip = True EndIf 
If i == UIA_StatusBarControlTypeId then iSkip = True EndIf 
If i == UIA_TabControlTypeId then iSkip = True EndIf 
If i == UIA_ToolBarControlTypeId then iSkip = True EndIf 
If i == UIA_ToolTipControlTypeId then iSkip = True EndIf 
If i == UIA_TreeItemControlTypeId then iSkip = True EndIf 
If i == UIA_GroupControlTypeId then iSkip = True EndIf 
If i == UIA_ThumbControlTypeId then iSkip = True EndIf 
If i == UIA_DataItemControlTypeId then iSkip = True EndIf 
If i == UIA_DocumentControlTypeId then iSkip = True EndIf 
If i == UIA_SplitButtonControlTypeId then iSkip = True EndIf 
If i == UIA_WindowControlTypeId then iSkip = True EndIf 
If i == UIA_PaneControlTypeId then iSkip = True EndIf 
If i == UIA_TitleBarControlTypeId then iSkip = True EndIf 
If i == UIA_SeparatorControlTypeId then iSkip = True EndIf 
If i == UIA_SemanticZoomControlTypeId then iSkip = True EndIf 
If i == UIA_AppBarControlTypeId then iSkip = True EndIf 

; nur Controls zur Liste hinzufügen, die zuvor nicht aussortiert wurden 
If !iSkip then
AddControlToControlTypeMenu (i)
EndIf 
EndFor

PlaySound (FindJAWSSoundFile (cControlsReadySound))
; Menü anzeigen 
StartMenuLayer()
EndScript


; -------------------------------------------------------------------------------------------------------
; Beispiel zum Anzeigen eines Menüs mit JAWS-Funktionen
; -------------------------------------------------------------------------------------------------------

Script StartJAWSMenu()
var
string sJAWSDirectory = GetJAWSDirectory (),
string sJAWSHelpDirectory = GetJAWSHelpDirectory (),
string sJAWSSettingDirectory = GetJAWSSettingsDirectory (),
string sJAWSSharedDirectory = GetSharedScriptsDirectory (True),
string sJAWSSharedScriptsDirectory = GetSharedScriptsDirectory (False),
string sScript = GetScriptFileName (True),
string sSpeechHistory = GetSpeechHistory (), 
int iSpeechHistoryCount = StringSegmentCount (sSpeechHistory, "\13\10"), 
int i, 
string sTemp

if giMenus then
PerformScript FindChar(GetCurrentScriptKeyName ())
Return
EndIf 

NewXMLMenu ("JAWS Menü")

; HTML-Menü nur anzeigen, wenn ein Browser aktiv ist 
sScript = StringLower (sScript)
If (sScript == "internet explorer.jsb") 
|| (sScript == "microsoftedge.jsb") 
|| (sScript == "chrome.jsb") 
|| (sScript == "firefox.jsb")  then
CreateMenu ("Html")
       CreateMenuEntry ("ARIA-Dialog", "", "function", "DlgAriaLiveRegionFilterText")
       CreateMenuEntry ("Linkliste", "", "function", "dlgListOfLinks")
       CreateMenuEntry ("Lesezeichen", "", "function", "DlgListOfPlaceMarkers")
EndIf ; If (sScript == "internet ...

; JAWS-Verzeichnisse im Explorer öffnen 
CreateMenu ("JAWS-Verzeichnisse")
       CreateMenuEntry ("Programmverzeichnis", "", "Explorer", sJAWSDirectory)
       CreateMenuEntry ("Hilfeverzeichnis", "", "Explorer", sJAWSHelpDirectory)
       CreateMenuEntry ("Einstellungsverzeichnis", "", "Explorer", sJAWSSettingDirectory)
       CreateMenuEntry ("Anwenderskriptverzeichnis", "", "Explorer", sJAWSSettingDirectory)
       CreateMenuEntry ("Gemeinsame Einstellungen", "", "Explorer", sJAWSSharedDirectory)
       CreateMenuEntry ("Gemeinsame Skripts", "", "Explorer", sJAWSSharedScriptsDirectory)

 CreateMenu ("Einstellungen")
       CreateMenuEntry ("Anwendungseinstellungen", "Einfügen+V", "script", "StartScript|AdjustBrailleOptions")
       CreateMenuEntry ("Einstellungsverwaltung", "Einfügen+6", "script", "SettingsCenter")
       CreateMenuEntry ("HTML-Einstellungen", "", "script", "StartScript|AdjustHTMLSettings")
       CreateMenuEntry ("Virteuelle-HTML-Einstellungen", "", "script", "StartScript|VirtualHtmlFeatures")
       CreateMenuEntry ("JAWS-Einstellungen anpassen", "", "script", "AdjustJAWSOptions")
       CreateMenuEntry ("Flexible Web Einstellungen", "", "script", "DoFlexibleWebDialog")
       CreateMenuEntry ("Schnellnavigationstasten", "", "function", "RunNavQuickKeysManager")

 CreateMenu ("Hilfsprogramme")
       CreateMenuEntry ("Text für Steuerelement festlegen (Prompt erstellen)", "Strg+Einfügen+Tab", "script", "CreatePrompt")
       CreateMenuEntry ("Wörterbuchmanager", "Einfügen+D", "script", "DictionaryManager")
       CreateMenuEntry ("JAWS-Anwendungsfenster", "Einfügen+J", "script", "GestureJAWSWindow")
       CreateMenuEntry ("Manager", "Einfügen + F2", "script", "StartScript|RunJAWSManager")
       CreateMenuEntry ("Suche", "Einfügen+Strg+F", "script", "StartScript|JAWSFind")
       CreateMenuEntry ("Befehle suchen", "Einfügen+Leertaste, gefolgt von J", "script", "LaunchCommandsSearch")
       CreateMenuEntry ("Tastaturmanager", "Einfügen+8", "script", "KeyboardManager")
       CreateMenuEntry ("Symbol einfügen", "Alt+F12", "script", "StartScript|Language")
       CreateMenuEntry ("Infobereich-Symbole", "Einfügen+F11", "script", "StartScript|ListTaskTrayIcons")
       CreateMenuEntry ("Research-It", "", "script", "StartScript|ResearchIt")
       CreateMenuEntry ("Skriptmanager", "", "script", "Scriptmanager")
       CreateMenuEntry ("Skriptmanager mit Default-Datei", "", "script", "ScriptmanagerDefault")

 CreateMenu ("Hilfe")
       CreateMenuEntry ("JAWS-Hilfe", "Einfügen+F1", "script", "JAWSHelp")
       CreateMenuEntry ("Hilfe-Bildschirm der Hauptebene", "", "script", "BasicLayerHelp")
       CreateMenuEntry ("Mausecho-Hilfe", "", "script", "EchoLayerHelp")
       CreateMenuEntry ("Focus-Hilfe", "", "script", "FocusGDBHelpMessage")
       CreateMenuEntry ("Liste der Gesten", "", "script", "GestureListHelp")
       CreateMenuEntry ("Kurztastenauswahl", "Einfügen+H", "script", "HotKeyHelp ")

 CreateMenu ("Sonstiges")
       CreateMenuEntry ("Inhalt der Zwischenablage anzeigen", "", "function", "ShowClipboardTextInResultsViewer")
       CreateMenuEntry ("Querlesen-Dialog", "", "script", "StartScript|SkimReadDialog")
       CreateMenuEntry ("Stimmenprofil", "", "script", "StartScript|SelectAVoiceProfile")
       ; Menüpunkt nur hinzufügen, wenn ein Dialog aktiv ist 
       If DialogActive () then
       CreateMenuEntry ("Liste der Steuerelemente in Dialogen", "", "function", "DialogList")
       EndIf 
       CreateMenuEntry ("Sprachverlauf", "", "script", "ShowSpeechHistory")
       CreateMenuEntry ("Sprache auswählen", "", "script", "StartScript|SelectALanguage")


CreateMenu ("Sprachverlauf")
for i = 1 to iSpeechHistoryCount 
sTemp = StringSegment (sSpeechHistory, "\13\10", i)
       If !(sTemp == "") then
       CreateMenuEntry (sTemp, "", "function", "CopyToClipboard|"+sTemp)
       EndIf 
EndFor 

StartMenuLayer()
EndScript


; -------------------------------------------------------------------------------------------------------
; Beispiel zum Anzeigen eines Menüs mit Systemsteuerungselementen
; -------------------------------------------------------------------------------------------------------

; https://www.reddit.com/r/Windows10/comments/8ggozl/1803_volume_mixer_shortcut_name/

void Function SettingsMenu ()
var
object oShell = CreateObject("Wscript.Shell"),
string sPath 

CreateMenu ("Allgemein")
  CreateMenuEntry ("Allgemein", "Windows+I", "run", "ms-settings:")
  CreateMenuEntry ("Alte Systemsteuerung", "", "run", "explorer.exe shell:::{26EE0668-A00A-44D7-9371-BEB064C98683} ")
CreateMenu ("System")
  CreateMenuEntry ("Anzeige", "", "run", "ms-settings:display")
  CreateMenuEntry ("Nachtmodus", "", "run", "ms-settings:nightlight")
  CreateMenuEntry ("Bildschirm Rotation", "", "run", "ms-settings:screenrotation")
  CreateMenuEntry ("Benachrichtigungen und Aktionen", "", "run", "ms-settings:notifications")
  CreateMenuEntry ("Netzbetrieb und Energiesparen", "", "run", "ms-settings:powersleep")
  CreateMenuEntry ("Akku", "", "run", "ms-settings:batterysaver")
  CreateMenuEntry ("Akku Einstellungen", "", "run", "ms-settings:batterysaver")
  CreateMenuEntry ("Akku Details", "", "run", "ms-settings:batterysaver")
  CreateMenuEntry ("Speicher", "", "run", "ms-settings:storagesense")
  CreateMenuEntry ("Speicher für neuen Inhalt ändern", "", "run", "ms-settings:savelocations")
  CreateMenuEntry ("Freigeben von Speicherplatz ändern", "", "run", "ms-settings:storagepolicies")
  CreateMenuEntry ("Tablet-Modus", "", "run", "ms-settings:tabletmode")
  CreateMenuEntry ("Multitasking", "", "run", "ms-settings:multitasking")
  CreateMenuEntry ("Projizieren auf diesen PC", "", "run", "ms-settings:project")
  CreateMenuEntry ("Remotedesktop", "", "run", "ms-settings:remotedesktop")
  CreateMenuEntry ("Info", "", "run", "ms-settings:about")
  CreateMenuEntry ("Verschlüsselung", "", "run", "ms-settings:deviceencryption")
  CreateMenuEntry ("Gemeinsame Nutzung", "", "run", "ms-settings:crossdevice")
  CreateMenuEntry ("Flugzeugmodus", "", "run", "ms-settings:proximity")
CreateMenu ("Surface Hub")
  CreateMenuEntry ("Willkommen", "", "run", "ms-settings:surfacehub-welcome")
  CreateMenuEntry ("Konten", "", "run", "ms-settings:surfacehub-accounts")
  CreateMenuEntry ("Aufruf", "", "run", "ms-settings:surfacehub-calling")
  CreateMenuEntry ("Gerätemanager", "", "run", "ms-settings:surfacehub-devicemanagenent")
  CreateMenuEntry ("Aufräumen", "", "run", "ms-settings:surfacehub-sessioncleanup")
CreateMenu ("Geräte")
 CreateMenuEntry ("Bluetooth und andere Geräte ", "", "run", "ms-settings:bluetooth")
;  CreateMenuEntry ("Bluetooth und andere Geräte", "", "run", "ms-settings:connecteddevices")
  CreateMenuEntry ("Drucker und Scanner", "", "run", "ms-settings:printers")
  CreateMenuEntry ("Maus", "", "run", "ms-settings:mousetouchpad")
  CreateMenuEntry ("Touchpad", "", "run", "ms-settings:devices-touchpad")
  CreateMenuEntry ("Eingabe", "", "run", "ms-settings:typing")
  CreateMenuEntry ("Stift und Windows Ink", "", "run", "ms-settings:pen")
  CreateMenuEntry ("Surface Dial Einstellungen", "", "run", "ms-settings:wheel")
  CreateMenuEntry ("Automatische Wiedergabe", "", "run", "ms-settings:autoplay")
  CreateMenuEntry ("USB", "", "run", "ms-settings:usb")
CreateMenu ("Handy")
  CreateMenuEntry ("Handy Einstellungen", "", "run", "ms-settings:mobile-devices")
  CreateMenuEntry ("Handy hinzufügen", "", "run", "ms-settings:mobile-devices-addphone")
CreateMenu ("Netzwerk und Internet")
  CreateMenuEntry ("Status", "", "run", "ms-settings:network-status")
  CreateMenuEntry ("Ethernet", "", "run", "ms-settings:network-ethernet")
  CreateMenuEntry ("Eingabe Drahtlosgeräte oder WLAN", "", "run", "ms-settings:network-directaccess")
  CreateMenuEntry ("WLAN", "", "run", "ms-settings:network-wifi")
  CreateMenuEntry ("WLAN Calling", "", "run", "ms-settings:network-wificalling")
  CreateMenuEntry ("WLAN Einstellungen", "", "run", "ms-settings:network-wifisettings")
  CreateMenuEntry ("DFÜ", "", "run", "ms-settings:network-dialup")
  CreateMenuEntry ("NFC", "", "run", "ms-settings:nfctransactions")
  CreateMenuEntry ("Mobilfunk und SIM", "", "run", "ms-settings:network-cellular")
  CreateMenuEntry ("Mobiler Hotspot", "", "run", "ms-settings:network-mobilehotspot")
  CreateMenuEntry ("Flugzeugmodus", "", "run", "ms-settings:network-airplanemode")
  CreateMenuEntry ("VPN", "", "run", "ms-settings:network-vpn")
  CreateMenuEntry ("Datennutzung", "", "run", "ms-settings:datausage")
  CreateMenuEntry ("Proxy", "", "run", "ms-settings:network-proxy")

CreateMenu ("Personalisierung")
  CreateMenuEntry ("Personalisierung", "", "run", "ms-settings:personalization")
  CreateMenuEntry ("Hintergrund", "", "run", "ms-settings:personalization-background")
  CreateMenuEntry ("Farben", "", "run", "ms-settings:colors")
  CreateMenuEntry ("Sperrbildschirm", "", "run", "ms-settings:lockscreen")
  CreateMenuEntry ("Designs", "", "run", "ms-settings:themes")
  CreateMenuEntry ("Schriftarten", "", "run", "ms-settings:fonts")
  CreateMenuEntry ("Start", "", "run", "ms-settings:personalization-start")
  CreateMenuEntry ("Taskleiste", "", "run", "ms-settings:taskbar")

CreateMenu ("Apps")
  CreateMenuEntry ("Apps & Features", "", "run", "ms-settings:appsfeatures")
  CreateMenuEntry ("Optionale Features", "", "run", "ms-settings:optionalfeatures")
  CreateMenuEntry ("Standard-Apps", "", "run", "ms-settings:defaultapps")
  CreateMenuEntry ("Offline-Karten ", "", "run", "ms-settings:maps")
  CreateMenuEntry ("Offline Karten herunterladen", "", "run", "ms-settings:maps-downloadmaps")
  CreateMenuEntry ("Apps für Websites", "", "run", "ms-settings:appsforwebsites")
  CreateMenuEntry ("Videowiedergabe", "", "run", "ms-settings:videoplayback")

CreateMenu ("Konten")
  CreateMenuEntry ("Ihre Infos", "", "run", "ms-settings:yourinfo")
  CreateMenuEntry ("E-Mail und App-Konten", "", "run", "ms-settings:emailandaccounts")
  CreateMenuEntry ("Anmeldeoptionen ", "", "run", "ms-settings:signinoptions")
  CreateMenuEntry ("Windows Hello Setup", "", "run", "ms-settings:signinoptions-launchfaceenrollment")
  CreateMenuEntry ("Windows Hello Fingerabdruck Setup", "", "run", "ms-settings:signinoptions-launchfingerprintenrollment")
  CreateMenuEntry ("Auf Arbeits- oder Schulkonto zugreifen", "", "run", "ms-settings:workplace")
  CreateMenuEntry ("Familie und weitere Kontakte", "", "run", "ms-settings:otherusers")
  CreateMenuEntry ("Einstellungen synchronisieren", "", "run", "ms-settings:sync")
  CreateMenuEntry ("Windows Hello", "", "run", "ms-settings:signinoptions")
  CreateMenuEntry ("Windows Hello", "", "run", "ms-settings:signinoptions-launchfingerprintenrollment")

CreateMenu ("Zeit und Sprache")
  CreateMenuEntry ("Datum und Uhrzeit ", "", "run", "ms-settings:dateandtime")
  CreateMenuEntry ("Datum und Uhrzeit - Tastatur", "", "run", "ms-settings:keyboard")
  CreateMenuEntry ("Region und Sprache", "", "run", "ms-settings:regionlanguage")
  CreateMenuEntry ("Spracherkennung", "", "run", "ms-settings:speech")

CreateMenu ("Spielen")
  CreateMenuEntry ("Spieleleiste", "", "run", "ms-settings:gaming-gamebar")
  CreateMenuEntry ("Game DVR", "", "run", "ms-settings:gaming-gamedvr")
  CreateMenuEntry ("Übertragung", "", "run", "ms-settings:gaming-broadcasting")
  CreateMenuEntry ("Spielmodus", "", "run", "ms-settings:gaming-gamemode")
  CreateMenuEntry ("TruePlay", "", "run", "ms-settings:gaming-trueplay")
  CreateMenuEntry ("Xbox-Netzwerk", "", "run", "ms-settings:gaming-xboxnetworking")

CreateMenu ("Erleichterte Bedienung")
  CreateMenuEntry ("Sprachausgabe", "", "run", "ms-settings:easeofaccess-narrator")
  CreateMenuEntry ("Bildschirmlupe", "", "run", "ms-settings:easeofaccess-magnifier")
  CreateMenuEntry ("Hoher Kontrast", "", "run", "ms-settings:easeofaccess-highcontrast")
  CreateMenuEntry ("Untertitel für Hörgeschädigte", "", "run", "ms-settings:easeofaccess-closedcaptioning")
  CreateMenuEntry ("Tastatur", "", "run", "ms-settings:easeofaccess-keyboard")
  CreateMenuEntry ("Maus", "", "run", "ms-settings:easeofaccess-mouse")
  CreateMenuEntry ("Weitere Optionen", "", "run", "ms-settings:easeofaccess-otheroptions")

CreateMenu ("Cortana")
  CreateMenuEntry ("Mit Cortana sprechen ", "", "run", "ms-settings:cortana")
  CreateMenuEntry ("Cortana Spracheinstellung", "", "run", "ms-settings:cortana-language")
  CreateMenuEntry ("Berechtigung und Verlauf", "", "run", "ms-settings:cortana-permissions")
  CreateMenuEntry ("Benachrichtigungen", "", "run", "ms-settings:cortana-notifications")
  CreateMenuEntry ("Weitere Details", "", "run", "ms-settings:cortana-moredetails")

CreateMenu ("Datenschutz")
  CreateMenuEntry ("Datenschutz", "", "run", "ms-settings:privacy")
  CreateMenuEntry ("Allgemein", "", "run", "ms-settings:privacy-general")
  CreateMenuEntry ("Position", "", "run", "ms-settings:privacy-location")
  CreateMenuEntry ("Kamera", "", "run", "ms-settings:privacy-webcam")
  CreateMenuEntry ("Mikrofon", "", "run", "ms-settings:privacy-microphone")
  CreateMenuEntry ("Benachrichtigungen", "", "run", "ms-settings:privacy-notifications")
  CreateMenuEntry ("Spracherkennung, Freihand und Eingabe", "", "run", "ms-settings:privacy-speechtyping")
  CreateMenuEntry ("Kontoinformationen", "", "run", "ms-settings:privacy-accountinfo")
  CreateMenuEntry ("Kontakte", "", "run", "ms-settings:privacy-contacts")
  CreateMenuEntry ("Kalender", "", "run", "ms-settings:privacy-calendar")
  CreateMenuEntry ("Anrufliste", "", "run", "ms-settings:privacy-callhistory")
  CreateMenuEntry ("E-Mail", "", "run", "ms-settings:privacy-email")
  CreateMenuEntry ("Aufgaben", "", "run", "ms-settings:privacy-tasks")
  CreateMenuEntry ("Messaging (Nachrichten)", "", "run", "ms-settings:privacy-messaging")
  CreateMenuEntry ("Funkempfang", "", "run", "ms-settings:privacy-radios")
  CreateMenuEntry ("Weitere Geräte", "", "run", "ms-settings:privacy-customdevices")
  CreateMenuEntry ("Feedback und Diagnose", "", "run", "ms-settings:privacy-feedback")
  CreateMenuEntry ("Hintergrund-Apps", "", "run", "ms-settings:privacy-backgroundapps")
  CreateMenuEntry ("App-Diagnose", "", "run", "ms-settings:privacy-appdiagnostics")
  CreateMenuEntry ("Automatische Dateidownloads", "", "run", "ms-settings:privacy-automaticfiledownloads")

CreateMenu ("Windows Update")
  CreateMenuEntry ("Windows Update ", "", "run", "ms-settings:windowsupdate")
  CreateMenuEntry ("Nach Updates suchen", "", "run", "ms-settings:windowsupdate-action")
  CreateMenuEntry ("Updateverlauf", "", "run", "ms-settings:windowsupdate-history")
  CreateMenuEntry ("Neustartoptionen", "", "run", "ms-settings:windowsupdate-restartoptions")
  CreateMenuEntry ("Erweiterte Einstellungen", "", "run", "ms-settings:windowsupdate-options")
  CreateMenuEntry ("Übermittlungsoptimierung", "", "run", "ms-settings:delivery-optimization")
  CreateMenuEntry ("Windows Defender", "", "run", "ms-settings:windowsdefender")
  CreateMenuEntry ("Sicherung", "", "run", "ms-settings:backup")
  CreateMenuEntry ("Problembehandlung", "", "run", "ms-settings:troubleshoot")
  CreateMenuEntry ("Wiederherstellung", "", "run", "ms-settings:recovery")
  CreateMenuEntry ("Aktivierung", "", "run", "ms-settings:activation")
  CreateMenuEntry ("Mein Gerät suchen", "", "run", "ms-settings:findmydevice")
  CreateMenuEntry ("Für Entwickler", "", "run", "ms-settings:developers")
  CreateMenuEntry ("Windows Insider-Programm", "", "run", "ms-settings:windowsinsider")
 
CreateMenu ("Mixed Reality")
  CreateMenuEntry ("Mixed Reality Einstellungen", "", "run", "ms-settings:holographic")
  CreateMenuEntry ("Mixed Reality Audio", "", "run", "ms-settings:holographic-audio")

CreateMenu ("Ordner (alle Benutzer)")
       sPath = oShell.SpecialFolders("AllUsersDesktop")
       CreateMenuEntry ("Desktop", "", "Explorer", sPath)
       sPath = oShell.SpecialFolders("AllUsersStartMenu")
       CreateMenuEntry ("Startmenü", "", "Explorer", sPath)
       sPath = oShell.SpecialFolders("AllUsersPrograms")
       CreateMenuEntry ("Programme", "", "Explorer", sPath)
       sPath = oShell.SpecialFolders("AllUsersStartup")
       CreateMenuEntry ("Autostart", "", "Explorer", sPath)

CreateMenu ("Ordner (aktueller Benutzer)")
      sPath = oShell.SpecialFolders("Desktop")
      CreateMenuEntry ("Desktop", "", "Explorer", sPath)
      sPath = oShell.SpecialFolders("Favorites")
      CreateMenuEntry ("Favoriten", "", "Explorer", sPath)
      sPath = oShell.SpecialFolders("Fonts")
      CreateMenuEntry ("Schriftarten", "", "Explorer", sPath)
      sPath = oShell.SpecialFolders("MyDocuments")
      CreateMenuEntry ("Dokumente", "", "Explorer", sPath)
      sPath = oShell.SpecialFolders("NetHood")
      CreateMenuEntry ("Netzwerk", "", "Explorer", sPath)
      sPath = oShell.SpecialFolders("PrintHood")
      CreateMenuEntry ("Drucker", "", "Explorer", sPath)
      sPath = oShell.SpecialFolders("Programs")
      CreateMenuEntry ("Programme (Startmenü)", "", "Explorer", sPath)
      sPath = oShell.SpecialFolders("Recent")
      CreateMenuEntry ("Kürzlich verwendet", "", "Explorer", sPath)
      sPath = oShell.SpecialFolders("SendTo")
      CreateMenuEntry ("Senden an", "", "Explorer", sPath)
      sPath = oShell.SpecialFolders("StartMenu")
      CreateMenuEntry ("Startmenü", "", "Explorer", sPath)
      sPath = oShell.SpecialFolders("Startup")
      CreateMenuEntry ("Autostart", "", "Explorer", sPath)
      sPath = oShell.SpecialFolders("Templates")
      CreateMenuEntry ("Vorlagen", "", "Explorer", sPath)

EndFunction 

Script StartSettingsMenu()

if giMenus then
PerformScript FindChar(GetCurrentScriptKeyName ())
Return
EndIf 

NewXMLMenu ("Windows Einstellungen")
SettingsMenu ()
StartMenuLayer()
EndScript

; -------------------------------------------------------------------------------------------------------
; Beispiel zum Anzeigen eines Menüs mit Symbolen zum Einfügen
; -------------------------------------------------------------------------------------------------------

Script StartInsertMenu ()

if giMenus then
PerformScript FindChar(GetCurrentScriptKeyName ())
Return
EndIf 

NewXMLMenu ("Einfügen-Menü")

CreateMenu ("Währung")
       CreateMenuEntry ("Euro", "", "function", "TypeString|€")
       CreateMenuEntry ("Euro Cent", "", "function", "TypeString|¢")
       CreateMenuEntry ("Pfund Sterling", "", "function", "TypeString|£")
       CreateMenuEntry ("Japanischer Yen", "", "function", "TypeString|¥")
       CreateMenuEntry ("Chinesischer Yuan", "", "function", "TypeString|¥")
       CreateMenuEntry ("Dollar", "", "function", "TypeString|$")
       CreateMenuEntry ("Cent", "", "function", "TypeString|¢")
       CreateMenuEntry ("Norwegische Krone", "", "function", "TypeString|Kr")
       CreateMenuEntry ("Schweizer Franken", "", "function", "TypeString|Fr")
       CreateMenuEntry ("Südkoreanischer Won", "", "function", "TypeString|₩")

CreateMenu ("Mathematische Symbole")

       CreateMenuEntry ("Neigung", "", "function", "TypeString|¬")
       CreateMenuEntry ("Makron", "", "function", "TypeString|¯")
       CreateMenuEntry ("Grad", "", "function", "TypeString|°")
       CreateMenuEntry ("im Quadrat / Hoch 2", "", "function", "TypeString|²")
       CreateMenuEntry ("Kubik / Hoch 3", "", "function", "TypeString|³")
       CreateMenuEntry ("Mittelpunkt", "", "function", "TypeString|·")
       CreateMenuEntry ("Hoch 1", "", "function", "TypeString|¹")
       CreateMenuEntry ("ein Viertel", "", "function", "TypeString|¼")
       CreateMenuEntry ("ein Halb", "", "function", "TypeString|½")
       CreateMenuEntry ("drei Viertel", "", "function", "TypeString|¾")
       CreateMenuEntry ("Multiplikation", "", "function", "TypeString|×")
       CreateMenuEntry ("Division", "", "function", "TypeString|÷")
       CreateMenuEntry ("Promille", "", "function", "TypeString|‰")
       CreateMenuEntry ("Bruch", "", "function", "TypeString|⁄")
       CreateMenuEntry ("Tiefgestellte 2 (etwa für CO₂ für Kohlenstoffdioxid)", "", "function", "TypeString|₂")
       CreateMenuEntry ("Tiefgestellte 3 (etwa für H₂CO₃ für Kohlensäure)", "", "function", "TypeString|₃")
       CreateMenuEntry ("Summenzeichen", "", "function", "TypeString|∑")
       CreateMenuEntry ("Minuszeichen", "", "function", "TypeString|−")
       CreateMenuEntry ("Quadratwurzel", "", "function", "TypeString|√")
       
       CreateMenuEntry ("daraus folgt", "", "function", "TypeString|⇒")
       CreateMenuEntry ("genau dann, wenn", "", "function", "TypeString|⇔")
       CreateMenuEntry ("ungefähr gleich", "", "function", "TypeString|≈")
       CreateMenuEntry ("ungleich", "", "function", "TypeString|≠")
       CreateMenuEntry ("kleiner als", "", "function", "TypeString|<")
       CreateMenuEntry ("größer als", "", "function", "TypeString|>")
       CreateMenuEntry ("kleiner gleich", "", "function", "TypeString|≤")
       CreateMenuEntry ("größer gleich", "", "function", "TypeString|≥")
       CreateMenuEntry ("identisch", "", "function", "TypeString|≡")
       CreateMenuEntry ("plus-minus", "", "function", "TypeString|±")
       CreateMenuEntry ("unendlisch", "", "function", "TypeString|∞")
       CreateMenuEntry ("Kreiszahl (Pi)", "", "function", "TypeString|π")
       CreateMenuEntry ("ist Element von", "", "function", "TypeString|")
       CreateMenuEntry ("für alle (für jedes)", "", "function", "TypeString|∀")
       CreateMenuEntry ("Durchschnittsmenge", "", "function", "TypeString|∩")
       CreateMenuEntry ("Vereinigungsmenge", "", "function", "TypeString|∪")
       CreateMenuEntry ("Komplementärmenge", "", "function", "TypeString|\\")
       CreateMenuEntry ("hochstellen (Potenz)", "", "function", "TypeString|^")
       CreateMenuEntry ("logisches und", "", "function", "TypeString|∧")
       CreateMenuEntry ("logisches oder", "", "function", "TypeString|∨")
       CreateMenuEntry ("logisches nicht", "", "function", "TypeString|¬")
       CreateMenuEntry ("normal (orthogonal)", "", "function", "TypeString|⊥")
       CreateMenuEntry ("Dreieck", "", "function", "TypeString|∆")

      
CreateMenu ("Arbeit")

       CreateMenuEntry ("Copyright-Zeichen", "", "function", "TypeString|©")
       CreateMenuEntry ("eingetragene Handelsmarke (Warenzeichen)", "", "function", "TypeString|®")
       CreateMenuEntry ("Firmenund", "", "function", "TypeString|&")
       CreateMenuEntry ("Handelsmarke, Trademark", "", "function", "TypeString|™")


CreateMenu ("diverse Symbole")

       CreateMenuEntry ("Ausgefüllter 5-zackiger Stern", "", "function", "TypeString|★")
       CreateMenuEntry ("Herz", "", "function", "TypeString|♥")
       CreateMenuEntry ("Telefon-Standort", "", "function", "TypeString|✆")
       CreateMenuEntry ("Briefumschlag-Symbol", "", "function", "TypeString|✉")
       CreateMenuEntry ("Flugzeug", "", "function", "TypeString|✈")
       CreateMenuEntry ("Haken", "", "function", "TypeString|✓")
       CreateMenuEntry ("Haken fett", "", "function", "TypeString|✔")
       CreateMenuEntry ("Raute", "", "function", "TypeString|◊")
       CreateMenuEntry ("Pik (Kartenspiel)", "", "function", "TypeString|♠")
       CreateMenuEntry ("Kreuz (Kartenspiel)", "", "function", "TypeString|♣")
       CreateMenuEntry ("Herz-Sonderzeichen (Kartenspiel)", "", "function", "TypeString|♥")
       CreateMenuEntry ("Karo (Kartenspiel)", "", "function", "TypeString|♦")
       CreateMenuEntry ("senkrechter Strich mit Unterbrechung", "", "function", "TypeString|¦")
       CreateMenuEntry ("Weibliche Ordnungszahl", "", "function", "TypeString|ª")
       CreateMenuEntry ("Männliuche Ordnungszahl", "", "function", "TypeString|º")
       CreateMenuEntry ("Absatzzeichen", "", "function", "TypeString|¶")
   
       CreateMenuEntry ("umgekehrtes Fragezeichen", "", "function", "TypeString|¿")
       CreateMenuEntry ("Ausgefüllter Kreis, Aufzählungszeichen", "", "function", "TypeString|•")
       CreateMenuEntry ("Dreifachpunkt, Punkt-Punkt-Punkt", "", "function", "TypeString|…")
       CreateMenuEntry ("Überstrich", "", "function", "TypeString|‾")
       CreateMenuEntry ("linke, eckige Klammer", "", "function", "TypeString|〈")
       CreateMenuEntry ("rechte, eckige Klammer", "", "function", "TypeString|〉")
       CreateMenuEntry ("Gedankenstrich", "", "function", "TypeString|–")
       CreateMenuEntry ("Gedankenstrich, groß", "", "function", "TypeString|—")

       CreateMenuEntry ("umgekehrtes Ausrufezeichen", "", "function", "TypeString|¡")
       CreateMenuEntry ("Paragraph", "", "function", "TypeString|§")
       CreateMenuEntry ("Umlaut mit Leerraum", "", "function", "TypeString|¨")
       CreateMenuEntry ("Akut mit Leerraum", "", "function", "TypeString|´")
       CreateMenuEntry ("Mikro (Einheit)", "", "function", "TypeString|µ")
       CreateMenuEntry ("Cedilla mit Leerraum", "", "function", "TypeString|¸")
       CreateMenuEntry ("Zirkumflex", "", "function", "TypeString|ˆ")
       CreateMenuEntry ("kleine Tilde", "", "function", "TypeString|˜")
       CreateMenuEntry ("Dolch", "", "function", "TypeString|†")
       CreateMenuEntry ("doppelter Dolch", "", "function", "TypeString|‡")
    
   
CreateMenu ("Allgmeine lateinische Zeichen")
       CreateMenuEntry ("großes lateinisches A mit Akut", "", "function", "TypeString|Á")
       CreateMenuEntry ("großes lateinisches AE = große lateinische Ligatur AE", "", "function", "TypeString|Æ")
       CreateMenuEntry ("kleines lateinisches ae = kleine lateinische Ligatur ae", "", "function", "TypeString|æ")
       CreateMenuEntry ("große lateinische Ligatur OE", "", "function", "TypeString|Œ")
       CreateMenuEntry ("kleine lateinische Ligatur oe", "", "function", "TypeString|œ")
       CreateMenuEntry ("großes lateinisches S mit Caron", "", "function", "TypeString|Š")
          
CreateMenu ("Gravis und Akzente")

       CreateMenuEntry ("Großbuchstabe A mit Gravis-Akzent", "", "function", "TypeString|À")
       CreateMenuEntry ("Großbuchstabe E mit Gravis-Akzent", "", "function", "TypeString|È")
       CreateMenuEntry ("Großbuchstabe I mit Gravis-Akzent", "", "function", "TypeString|Ì")
       CreateMenuEntry ("Großbuchstabe O mit Gravis-Akzent", "", "function", "TypeString|Ò")
       CreateMenuEntry ("Großbuchstabe U mit Gravis-Akzent", "", "function", "TypeString|Ù")
       CreateMenuEntry ("Kleinbuchstabe a mit Gravis-Akzent", "", "function", "TypeString|à")
       CreateMenuEntry ("Kleinbuchstabe e mit Gravis-Akzent", "", "function", "TypeString|è")
       CreateMenuEntry ("Kleinbuchstabe i mit Gravis-Akzent", "", "function", "TypeString|¥")
       CreateMenuEntry ("Kleinbuchstabe o mit Gravis-Akzent", "", "function", "TypeString|ò")
       CreateMenuEntry ("Kleinbuchstabe u mit Gravis-Akzent", "", "function", "TypeString|ù")       
       CreateMenuEntry ("Großbuchstabe A mit Accent aigu", "", "function", "TypeString|Á")
       CreateMenuEntry ("Großbuchstabe E mit Accent aigu", "", "function", "TypeString|É")
       CreateMenuEntry ("Großbuchstabe I mit Accent aigu", "", "function", "TypeString|Í")       
       CreateMenuEntry ("Großbuchstabe O mit Accent aigu", "", "function", "TypeString|Ó")
       CreateMenuEntry ("Großbuchstabe U mit Accent aigu", "", "function", "TypeString|Ú")
       CreateMenuEntry ("Großbuchstabe Y mit Accent aigu", "", "function", "TypeString|Ý")       
       CreateMenuEntry ("Kleinbuchstabe a mit Accent aigu", "", "function", "TypeString|á")
       CreateMenuEntry ("Kleinbuchstabe e mit Accent aigu", "", "function", "TypeString|é")
       CreateMenuEntry ("Kleinbuchstabe i mit Accent aigu", "", "function", "TypeString|í")       
       CreateMenuEntry ("Kleinbuchstabe o mit Accent aigu", "", "function", "TypeString|ó")
       CreateMenuEntry ("Kleinbuchstabe u mit Accent aigu", "", "function", "TypeString|ú")
       CreateMenuEntry ("Kleinbuchstabe y mit Accent aigu", "", "function", "TypeString|ý")       
  
CreateMenu ("Musiknoten und musikalische Sonderzeichen")     
       CreateMenuEntry ("Achtelnote", "", "function", "TypeString|♪")
       CreateMenuEntry ("Achtelnote mit Balken", "", "function", "TypeString|♫")
       CreateMenuEntry ("Erniedrigungszeichen (b Notenzeichen", "", "function", "TypeString|♭")
       CreateMenuEntry ("Kreuz (Musiknote)", "", "function", "TypeString|♯") 

CreateMenu ("Redezeichen")       
       CreateMenuEntry ("Doppelt gewinkelte Klammer auf", "", "function", "TypeString|«")       
       CreateMenuEntry ("Doppelt gewinkelte Klammer zu", "", "function", "TypeString|»")
       CreateMenuEntry ("Primezeichen, Anführungszeichen (Minuten-Zeichen)", "", "function", "TypeString|′")
       CreateMenuEntry ("Doppel-Prime-Zeichen, Anführungszeichen (Sekunden-Zeichen)", "", "function", "TypeString|″")        
       CreateMenuEntry ("Apostroph, Anführungszeichen oben (links)", "", "function", "TypeString|‘")       
       CreateMenuEntry ("Apostroph, Anführungszeichen oben (rechts)", "", "function", "TypeString|’")
       CreateMenuEntry ("einfüaches Anführungszeichen unten", "", "function", "TypeString|‚")
       CreateMenuEntry ("Doppeltes Anführungszeichen oben (links)", "", "function", "TypeString|“")        
       CreateMenuEntry ("Doppeltes Anführungszeichen oben (rechts)", "", "function", "TypeString|”")       
       CreateMenuEntry ("Doppeltes Anführungszeichen unten", "", "function", "TypeString|„")
       CreateMenuEntry ("einfaches nach links zeigendes spitzes Anführungszeichen", "", "function", "TypeString|‹")
       CreateMenuEntry ("einfaches nach rechts zeigendes spitzes Anführungszeichen ", "", "function", "TypeString|›")        
       
     
CreateMenu ("Pfeile") 
       CreateMenuEntry ("Normaler Pfeil nach rechts", "", "function", "TypeString|→")
       CreateMenuEntry ("Dicker Pfeil nach rechts", "", "function", "TypeString|➔")
       CreateMenuEntry ("Pfeil nach links", "", "function", "TypeString|←")
       CreateMenuEntry ("Pfeil nach oben", "", "function", "TypeString|↑")
       CreateMenuEntry ("Pfeil nach rechts", "", "function", "TypeString|→")
       CreateMenuEntry ("Pfeil nach unten", "", "function", "TypeString|↓")
       CreateMenuEntry ("Pfeil nach links und rechts", "", "function", "TypeString|↔")
       CreateMenuEntry ("Doppelpfeil nach rechts", "", "function", "TypeString|⇒")
       CreateMenuEntry ("Doppelpfeil nach links und rechts", "", "function", "TypeString|⇔")
       CreateMenuEntry ("Dicker Pfeil nach rechs", "", "function", "TypeString|➨")
       CreateMenuEntry ("gestuachter dicker Pfeil, quadratisch", "", "function", "TypeString|➧")
       CreateMenuEntry ("Dicker Pfeil nach unten und rechts geboten", "", "function", "TypeString|➥")
       CreateMenuEntry ("Dicker Pfeil nach oben und rechts gebogen", "", "function", "TypeString|➦")
       CreateMenuEntry ("Dicker Pfeil nach rechts", "", "function", "TypeString|➨")
       CreateMenuEntry ("Weißter Pfeil nach rechts mit Rechtsschatten", "", "function", "TypeString|➩")
       CreateMenuEntry ("Dicker Pfeil nach rechts mit freiter Spitze ", "", "function", "TypeString|➔")
       CreateMenuEntry ("Dicker pfeil nach rechts-unten", "", "function", "TypeString|➘")
       CreateMenuEntry ("Dicker Pfeil nach rechts", "", "function", "TypeString|➙")
       CreateMenuEntry ("Dicker Pfeil nach rechts-oben", "", "function", "TypeString|➚")
       CreateMenuEntry ("Pfeil nach rechts mit großer Spitze", "", "function", "TypeString|➛")
       CreateMenuEntry ("Dicker Pfeil nach rechts mit abgerundeten Balken ", "", "function", "TypeString|➜")
       CreateMenuEntry ("Pfeil nach rechts mit Dreiecksspitze", "", "function", "TypeString|➝")
       CreateMenuEntry ("Dicker Pfeil nach rechts mit Dreiecksspitze", "", "function", "TypeString|➞")
       CreateMenuEntry ("Strichlierter Pfeil nach rechts Dreiecksspitze", "", "function", "TypeString|➟")
       CreateMenuEntry ("Dicker strichlierter Pfeil nach rechts mit Dreiecksspitze ", "", "function", "TypeString|➠")       
       CreateMenuEntry ("Schwarzer Pfeil nach rechts", "", "function", "TypeString|➡")
       CreateMenuEntry ("3D-Pfeil nach rechts, oben weiß", "", "function", "TypeString|➢")
       CreateMenuEntry ("3D-Pfeil nach rechts, unten weiß", "", "function", "TypeString|➣")
       CreateMenuEntry ("Ausgefüllter 3D-Pfeil nach rechts", "", "function", "TypeString|➤")
       CreateMenuEntry ("Dicker Pfeil nach rechts, weiß mit Linksschatten", "", "function", "TypeString|➪")
       CreateMenuEntry ("Nach hinten gekippter Pfeil nach rechts mit Schatten", "", "function", "TypeString|➫")
       CreateMenuEntry ("Nach vorn gekippter Pfeil nach rechts mit Schatten", "", "function", "TypeString|➬")
       CreateMenuEntry ("Pfeil nach rechts, weiß, quadratisch mit Schatten rechts unten ", "", "function", "TypeString|➭")
       CreateMenuEntry ("Pfeil nach rechts, weiß, quadratisch mit Schatten rechts oben", "", "function", "TypeString|➮")
       CreateMenuEntry ("Dicker, weißer Pfeil nach rechts mit Schatten unten", "", "function", "TypeString|➯")
       CreateMenuEntry ("Dicker, weißer Pfeil nach rechts mit Schatten oben", "", "function", "TypeString|➱")
       CreateMenuEntry ("Dicker, weißer Pfeil nach rechts im schwarzen Kreis", "", "function", "TypeString|➲")
       CreateMenuEntry ("Pfeil-und-Bogen-förmiger Pfeil nach rechts", "", "function", "TypeString|➳")
       CreateMenuEntry ("Pfeil-und-Bogen-förmiger Pfeil nach rechts-unten", "", "function", "TypeString|➴")
       CreateMenuEntry ("Pfeil-und-Bogen-förmiger Pfeil nach rechts", "", "function", "TypeString|➵")
       CreateMenuEntry ("Pfeil-und-Bogen-förmiger Pfeil nach rechts-oben", "", "function", "TypeString|➶")
       CreateMenuEntry ("Pfeil-und-Bogen-förmiger Pfeil nach rechts-unten", "", "function", "TypeString|➷")
       CreateMenuEntry ("Pfeil-und-Bogen-förmiger Pfeil nach rechts", "", "function", "TypeString|➸")
       CreateMenuEntry ("Pfeil-und-Bogen-förmiger Pfeil nach rechts-oben", "", "function", "TypeString|➹")
       CreateMenuEntry ("Pfeil nach rechts mit tropfenförmigem Widerhaken", "", "function", "TypeString|➺")
       CreateMenuEntry ("Dicker Pfeil nach rechts mit tropfenförmigem Schaft", "", "function", "TypeString|➻")
       CreateMenuEntry ("Pfeil nach rechts, geschwungen", "", "function", "TypeString|➽")
       CreateMenuEntry ("Doppelpfeil nach rechts", "", "function", "TypeString|➾")
       
CreateMenu ("Sterne")
       CreateMenuEntry ("Davidstern", "", "function", "TypeString|✡")
       CreateMenuEntry ("4-eckig gefüllter Stern", "", "function", "TypeString|✦")
       CreateMenuEntry ("weißer 4-eckiger Stern", "", "function", "TypeString|✧")
       CreateMenuEntry ("weißer 5-eckiger Stern", "", "function", "TypeString|✩")
       CreateMenuEntry ("wweißer 5-eckiger Stern im schwarzen Kreis", "", "function", "TypeString|✪")
       CreateMenuEntry ("schwarzer 5-eckiger Stern mit offener Mitte", "", "function", "TypeString|✫")
       CreateMenuEntry ("weißter 5-eckiger Stern mit schwarzer Mitte", "", "function", "TypeString|✬")
       CreateMenuEntry ("schwarzer 5-eckiger Stern, gefüllt, mit Kontur", "", "function", "TypeString|✭")
       CreateMenuEntry ("dicker schwarzer 5-eckiger Stern, gefüllt, mit Kontur", "", "function", "TypeString|✮")
       CreateMenuEntry ("weißer, fünfzackiger Stern, leer, mit Schatten", "", "function", "TypeString|✰")
       CreateMenuEntry ("großes Sternchen ", "", "function", "TypeString|✱")
       CreateMenuEntry ("Sternchen mit offener Mitte", "", "function", "TypeString|✲")
       CreateMenuEntry ("achtarmiges Sternchen ", "", "function", "TypeString|✳")
       CreateMenuEntry ("schwarzer, achtzackiger Stern", "", "function", "TypeString|✴")
       CreateMenuEntry ("achtarmiges Windrädchen", "", "function", "TypeString|✵")
       CreateMenuEntry ("sechszackiger schwazrer Stern", "", "function", "TypeString|✶")
       CreateMenuEntry ("gradlinig achtzackiger schwarzer Stern", "", "function", "TypeString|✷")
       CreateMenuEntry ("dicker, geradlinig, achtzackiger Stern", "", "function", "TypeString|✸")
       CreateMenuEntry ("schwarzer, zwölfzackiger Stern", "", "function", "TypeString|✹")
       CreateMenuEntry ("sechzehnarmiges Sternchen", "", "function", "TypeString|✺")
       CreateMenuEntry ("Tropfensternchen", "", "function", "TypeString|✻")
       CreateMenuEntry ("Tropfensternchen mit offener Mitte", "", "function", "TypeString|✼")
       CreateMenuEntry ("dickes Tropfensternchen", "", "function", "TypeString|✽")
       CreateMenuEntry ("achtzackiger Stern mit offener Mitte im Kreis", "", "function", "TypeString|❂")
       CreateMenuEntry ("dickes, tropfenförmiges Windrädchen", "", "function", "TypeString|❃")
       CreateMenuEntry ("Kugelsternchen ", "", "function", "TypeString|❉")
       CreateMenuEntry ("Propellersternchen aus 8 Tropfen", "", "function", "TypeString|❊")
       CreateMenuEntry ("dickes Propellersternchen aus 8 Tropfen", "", "function", "TypeString|❋")
            
CreateMenu ("Sonstige Zeichen")
       CreateMenuEntry ("Ausgefüllter Kreis, Aufzählungszeichen", "", "function", "TypeString|•")
       CreateMenuEntry ("Schere mit oberer Klinge", "", "function", "TypeString|✁")
       CreateMenuEntry ("schwarze Schere", "", "function", "TypeString|✂")
       CreateMenuEntry ("Schere mit unerer Klinge", "", "function", "TypeString|✃")
       CreateMenuEntry ("weiße Schere", "", "function", "TypeString|✄")
       CreateMenuEntry ("Telefon-Sandor", "", "function", "TypeString|✆")
       CreateMenuEntry ("Tonband, Bandlaufwerk", "", "function", "TypeString|✇")
       CreateMenuEntry ("Flugzeug", "", "function", "TypeString|✈")
       CreateMenuEntry ("Briefumschalg, E-Mail", "", "function", "TypeString|✉")
       CreateMenuEntry ("Fiedens-, Vicory bzw. Peace-Zeichen", "", "function", "TypeString|✌")
       CreateMenuEntry ("Schreibende Hand", "", "function", "TypeString|✍")
       CreateMenuEntry ("Stift nach rechts unen", "", "function", "TypeString|✎")
       CreateMenuEntry ("Stift", "", "function", "TypeString|✏")
       CreateMenuEntry ("Stift nach rechts oben", "", "function", "TypeString|✐")
       CreateMenuEntry ("weiße Schreibfederspitze", "", "function", "TypeString|✑")
       CreateMenuEntry ("schwazre Schreibfederspitze", "", "function", "TypeString|✒")
       CreateMenuEntry ("Häkchen dünn", "", "function", "TypeString|✓")
       CreateMenuEntry ("fettes Häkchen", "", "function", "TypeString|✔")
       CreateMenuEntry ("Kreuzchen als Malzeichen", "", "function", "TypeString|✕")
       CreateMenuEntry ("fettes Kreuzchen als Malzeichen", "", "function", "TypeString|✖")
       CreateMenuEntry ("Kreuzchen", "", "function", "TypeString|✗")
       CreateMenuEntry ("fettes Kreuzchen", "", "function", "TypeString|✘")
       CreateMenuEntry ("umrandesdes griechisches Kreuz", "", "function", "TypeString|✙")
       CreateMenuEntry ("Griechisches Kreuz (fett)", "", "function", "TypeString|✚")
       CreateMenuEntry ("Kreuz mi offener Mitte", "", "function", "TypeString|✛")
       CreateMenuEntry ("sarkes Kreuz mit offener Mitte", "", "function", "TypeString|✜")
       CreateMenuEntry ("lateinisches Kreuz (verstorben)", "", "function", "TypeString|✝")
       CreateMenuEntry ("lateinisches Kreuz (Schatten)", "", "function", "TypeString|✞")
       CreateMenuEntry ("umrandedes lateinisches Kreuz (Schatten)", "", "function", "TypeString|✟")
       CreateMenuEntry ("Malteser Kreuz", "", "function", "TypeString|✠")
       CreateMenuEntry ("Kreuz mit Punkten an den Enden", "", "function", "TypeString|✢")
       CreateMenuEntry ("Kreuz", "", "function", "TypeString|✣")
       CreateMenuEntry ("fettes Kreuz mit Punkten an den Enden (fett)", "", "function", "TypeString|✤")
       CreateMenuEntry ("Kreuz aus Pik-Enden", "", "function", "TypeString|✥")
       CreateMenuEntry ("6-eckige, schwarz-weiße Blume", "", "function", "TypeString|✾")
       CreateMenuEntry ("5-eckige, schwarze Blume", "", "function", "TypeString|✿")
       CreateMenuEntry ("4-blättrige Blume, weiß", "", "function", "TypeString|❀")
       CreateMenuEntry ("8-blättrige Blume, weiß", "", "function", "TypeString|❁")
       CreateMenuEntry ("Schneeflocke", "", "function", "TypeString|❄")
       CreateMenuEntry ("Schneeflocke", "", "function", "TypeString|❅")
       CreateMenuEntry ("Schneeflocke", "", "function", "TypeString|❆")
       CreateMenuEntry ("Funke", "", "function", "TypeString|❇")
       CreateMenuEntry ("Funke (fett)", "", "function", "TypeString|❈")
       CreateMenuEntry ("Weißer Kreis (mit Schatten)", "", "function", "TypeString|❍")
       CreateMenuEntry ("Weißes Quadrat (mit Schatten unten rechts)", "", "function", "TypeString|❏")
       CreateMenuEntry ("Weißes Quadrat (mit Schatten oben rechts)", "", "function", "TypeString|❐")
       CreateMenuEntry ("Weißes Quadrat (mit Schatten unten rechts)", "", "function", "TypeString|❑")
       CreateMenuEntry ("Weißes Quadrat (mit Schatten oben rechts)", "", "function", "TypeString|❒")
       CreateMenuEntry ("Kreuz aus 4 schwarzen Rauten", "", "function", "TypeString|❖")
       CreateMenuEntry ("Senkrechter Strich (dünn)", "", "function", "TypeString|❘")
       CreateMenuEntry ("Senkrechter Strich (dick)", "", "function", "TypeString|❙")
       CreateMenuEntry ("Senkrechter Strich (fett)", "", "function", "TypeString|❚")
       CreateMenuEntry ("Absatzzeichen (fett, geschwungen)", "", "function", "TypeString|❡")
       CreateMenuEntry ("Ausrufezeichen (fett in Herzform)", "", "function", "TypeString|❣")
       CreateMenuEntry ("Herzsymbol (sehr fett)", "", "function", "TypeString|❤")
       CreateMenuEntry ("Herzsymbol (sehr fett, um 90° gedreht)", "", "function", "TypeString|❥")

CreateMenu ("Griechisches Alphabet")
       CreateMenuEntry ("Alpha", "", "function", "TypeString|Α")
       CreateMenuEntry ("Beta", "", "function", "TypeString|Β")
       CreateMenuEntry ("Gamma", "", "function", "TypeString|Γ")
       CreateMenuEntry ("Delta", "", "function", "TypeString|Δ")
       CreateMenuEntry ("Epsilon", "", "function", "TypeString|Ε")
       CreateMenuEntry ("Zeta", "", "function", "TypeString|Ζ")
       CreateMenuEntry ("Eta", "", "function", "TypeString|Η")
       CreateMenuEntry ("Theta", "", "function", "TypeString|Θ")
       CreateMenuEntry ("Iota", "", "function", "TypeString|Ι")
       CreateMenuEntry ("Kappa", "", "function", "TypeString|Κ")
       CreateMenuEntry ("Lambda", "", "function", "TypeString|Λ")
       CreateMenuEntry ("Mu", "", "function", "TypeString|Μ")
       CreateMenuEntry ("Nu", "", "function", "TypeString|Ν")
       CreateMenuEntry ("Xi", "", "function", "TypeString|Ξ")
       CreateMenuEntry ("Omicron", "", "function", "TypeString|Ο")
       CreateMenuEntry ("Pi", "", "function", "TypeString|Π")
       CreateMenuEntry ("Rho", "", "function", "TypeString|Ρ")
       CreateMenuEntry ("Sigma", "", "function", "TypeString|Σ")
       CreateMenuEntry ("Tau", "", "function", "TypeString|Τ")
       CreateMenuEntry ("Ypsilon", "", "function", "TypeString|Υ")
       CreateMenuEntry ("Phi", "", "function", "TypeString|Φ")
       CreateMenuEntry ("Chi", "", "function", "TypeString|Χ")
       CreateMenuEntry ("Psi", "", "function", "TypeString|Ψ")
       CreateMenuEntry ("Omega", "", "function", "TypeString|Ω")
       CreateMenuEntry ("alpha", "", "function", "TypeString|α")
       CreateMenuEntry ("beta", "", "function", "TypeString|β")
       CreateMenuEntry ("gamma", "", "function", "TypeString|γ")
       CreateMenuEntry ("delta", "", "function", "TypeString|δ")
       CreateMenuEntry ("epsilon", "", "function", "TypeString|ε")
       CreateMenuEntry ("zeta", "", "function", "TypeString|ζ")
       CreateMenuEntry ("eta", "", "function", "TypeString|η")
       CreateMenuEntry ("theta", "", "function", "TypeString|θ")
       CreateMenuEntry ("iota", "", "function", "TypeString|ι")
       CreateMenuEntry ("kappa", "", "function", "TypeString|κ")
       CreateMenuEntry ("lambda", "", "function", "TypeString|λ")
       CreateMenuEntry ("mu", "", "function", "TypeString|μ")
       CreateMenuEntry ("nu", "", "function", "TypeString|ν")
       CreateMenuEntry ("xi", "", "function", "TypeString|ξ")
       CreateMenuEntry ("omicron", "", "function", "TypeString|ο")
       CreateMenuEntry ("pi", "", "function", "TypeString|π")
       CreateMenuEntry ("rho", "", "function", "TypeString|ρ")
       CreateMenuEntry ("finales sigma", "", "function", "TypeString|ς")
       CreateMenuEntry ("sigma", "", "function", "TypeString|σ")
       CreateMenuEntry ("tau", "", "function", "TypeString|τ")
       CreateMenuEntry ("ypsilon", "", "function", "TypeString|υ")
       CreateMenuEntry ("phi", "", "function", "TypeString|φ")
       CreateMenuEntry ("chi", "", "function", "TypeString|χ")
       CreateMenuEntry ("psi", "", "function", "TypeString|ψ")
       CreateMenuEntry ("omega", "", "function", "TypeString|ω")
       CreateMenuEntry ("theta", "", "function", "TypeString|ϑ")
       CreateMenuEntry ("Griechisches ypsilon (als Hook-Symbol)", "", "function", "TypeString|ϒ")
       CreateMenuEntry ("griechisches pi", "", "function", "TypeString|ϖ")

CreateMenu ("Lateinisches Alphabet")
       CreateMenuEntry ("lateinisches A mit Gravis", "", "function", "TypeString|À")
       CreateMenuEntry ("lateinisches A mit Zirkumflex", "", "function", "TypeString|Â")
       CreateMenuEntry ("lateinisches A mit Tilde", "", "function", "TypeString|Ã")
       CreateMenuEntry ("lateinisches A mit Ring", "", "function", "TypeString|Å")
       CreateMenuEntry ("lateinisches C mit Cedilla", "", "function", "TypeString|Ç")
       CreateMenuEntry ("lateinisches E mit Gravis", "", "function", "TypeString|È")
       CreateMenuEntry ("lateinisches E mit Akut", "", "function", "TypeString|É")
       CreateMenuEntry ("lateinisches E mit Zirkumflex", "", "function", "TypeString|Ê")
       CreateMenuEntry ("lateinisches E mit Diaeresis", "", "function", "TypeString|Ë")
       CreateMenuEntry ("lateinisches I mit Gravis", "", "function", "TypeString|Ì")
       CreateMenuEntry ("lateinisches I mit Akut", "", "function", "TypeString|Í")
       CreateMenuEntry ("lateinisches I mit Zirkumflex", "", "function", "TypeString|Î")
       CreateMenuEntry ("lateinisches I mit Umlaut", "", "function", "TypeString|Ï")
       CreateMenuEntry ("lateinisches ETH", "", "function", "TypeString|Ð")
       CreateMenuEntry ("lateinisches N mit Tilde", "", "function", "TypeString|Ñ")
       CreateMenuEntry ("lateinisches O mit Gravis", "", "function", "TypeString|Ò")
       CreateMenuEntry ("lateinisches O mit Akut", "", "function", "TypeString|Ó")
       CreateMenuEntry ("lateinisches O mit Zirkumflex", "", "function", "TypeString|Ô")
       CreateMenuEntry ("lateinisches O mit Tilde", "", "function", "TypeString|Õ")
       CreateMenuEntry ("kleines lateinisches h mit Querstrich", "", "function", "TypeString|ħ")
       CreateMenuEntry ("lateinisches O mit Querstrich", "", "function", "TypeString|Ø")
       CreateMenuEntry ("lateinisches U mit Gravis", "", "function", "TypeString|Ù")
       CreateMenuEntry ("lateinisches U mit Akut", "", "function", "TypeString|Ú")
       CreateMenuEntry ("lateinisches U mit Zirkumflex", "", "function", "TypeString|Û")
       CreateMenuEntry ("lateinisches Y mit Akut", "", "function", "TypeString|Ý")
       CreateMenuEntry ("lateinisches THORN", "", "function", "TypeString|Þ")
       CreateMenuEntry ("kleines lateinisches ß = ess-zed", "", "function", "TypeString|ß")
       CreateMenuEntry ("kleines lateinisches a mit Gravis", "", "function", "TypeString|à")
       CreateMenuEntry ("kleines lateinisches a mit Akut", "", "function", "TypeString|á")
       CreateMenuEntry ("kleines lateinisches a mit Zirkumflex", "", "function", "TypeString|â")
       CreateMenuEntry ("kleines lateinisches a mit Tilde", "", "function", "TypeString|ã")
       CreateMenuEntry ("kleines lateinisches a mit Ring = kleines lateinisches a Ring", "", "function", "TypeString|å")
       CreateMenuEntry ("kleines lateinisches c mit Cedilla", "", "function", "TypeString|ç")
       CreateMenuEntry ("kleines lateinisches e mit Gravis", "", "function", "TypeString|è")
       CreateMenuEntry ("kleines lateinisches e mit Akut", "", "function", "TypeString|é")
       CreateMenuEntry ("kleines lateinisches e mit Zirkumflex", "", "function", "TypeString|ê")
       CreateMenuEntry ("kleines lateinisches e mit Diaeresis", "", "function", "TypeString|ë")
       CreateMenuEntry ("kleines lateinisches i mit Gravis", "", "function", "TypeString|ì")
       CreateMenuEntry ("kleines lateinisches i mit Akut", "", "function", "TypeString|í")
       CreateMenuEntry ("kleines lateinisches i mit Zirkumflex", "", "function", "TypeString|î")
       CreateMenuEntry ("kleines lateinisches i mit Diaeresis", "", "function", "TypeString|ï")
       CreateMenuEntry ("kleines lateinisches Eth", "", "function", "TypeString|ð")
       CreateMenuEntry ("kleines lateinisches n mit Tilde", "", "function", "TypeString|ñ")
       CreateMenuEntry ("kleines lateinisches o mit Gravis", "", "function", "TypeString|ò")
       CreateMenuEntry ("kleines lateinisches o mit Akut", "", "function", "TypeString|ó")
       CreateMenuEntry ("kleines lateinisches o mit Zirkumflex", "", "function", "TypeString|ô")
       CreateMenuEntry ("kleines lateinisches o mit Tilde", "", "function", "TypeString|õ")
       CreateMenuEntry ("kleines lateinisches o mit Querstrich", "", "function", "TypeString|ø")
       CreateMenuEntry ("kleines lateinisches u mit Gravis", "", "function", "TypeString|ù")
       CreateMenuEntry ("kleines lateinisches u mit acute", "", "function", "TypeString|ú")
       CreateMenuEntry ("kleines lateinisches u mit circumflex", "", "function", "TypeString|û")
       CreateMenuEntry ("kleines lateinisches y mit Akut", "", "function", "TypeString|ý")
       CreateMenuEntry ("kleines lateinisches thorn", "", "function", "TypeString|þ")
       CreateMenuEntry ("kleines lateinisches y mit Diaeresis", "", "function", "TypeString|ÿ")
       CreateMenuEntry ("kleines lateinisches f mit Häkchen = Funktion = Florin", "", "function", "TypeString|ƒ")
       CreateMenuEntry ("kleines lateinisches s mit Caron", "", "function", "TypeString|š")
       CreateMenuEntry ("lateinisches Y mit Diaeresis", "", "function", "TypeString|Ÿ")
      
StartMenuLayer()
EndScript

Script TypeStr (string sFirst, string sSecond, int iSelect)
var
int i 

sFirst = StringReplaceSubstrings (sFirst, "#", "|")
sSecond = StringReplaceSubstrings (sSecond, "#", "|")

TypeString (sFirst)
TypeString (sSecond)
Pause ()
For i=1 to StringLength (sSecond)
TypeKey ("LeftArrow")
Pause ()
EndFor

If iSelect then
For i=1 to iSelect
TypeKey ("Shift+RightArrow")
Pause ()
EndFor
EndIf

EndScript

; -------------------------------------------------------------------------------------------------------
; Beispiel zum Anzeigen eines Menüs mit Emojis
; -------------------------------------------------------------------------------------------------------

Script StartEmojisMenu ()
var
int i, 
string sEmojis, 
string sChar


if giMenus then
PerformScript FindChar(GetCurrentScriptKeyName ())
Return
EndIf 

NewXMLMenu ("Emojis Menü")

CreateMenu ("Aktivitäten")
  CreateMenuEntry ("Auszeichnungen & Medaillen", "", "submenu", "")
  sEmojis = "🎖️|🏆|🏅|🥇|🥈|🥉"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor


  CreateMenuEntry ("Kunst & Handwerk", "", "submenu", "")
  sEmojis = "🎭|🖼️|🎨"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor

  CreateMenuEntry ("Spiele", "", "submenu", "")
  sEmojis = "🎱|🎯|🎮|🕹️|🎲|♠️|♥️|♦️|♣️|🃏|🀄|🎴|🔮|🎰|♟️"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor


  CreateMenuEntry ("Sport", "", "submenu", "")
  sEmojis = "⚽|⚾|🏀|🏐|🏈|🏉|🎾|🎳|🏏|🏑|🏒|🏓|🏸|🥊|🥋|🥅|⛳|⛸️|🎣|🎽|🎿|🛷|🥌"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor

  CreateMenuEntry ("Veranstaltungen", "", "submenu", "")
  sEmojis = "🎃|🎄|🎆|🎇|✨|🎈|🎉|🎊|🎋|🎍|🎎|🎏|🎐|🎑|🎀|🎁|🎗️|🎟️|🎫"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor

CreateMenu ("Essen und Trinken")
  CreateMenuEntry ("asiatisches Essen", "", "submenu", "")
  sEmojis = "🍱|🍘|🍙|🍚|🍛|🍜|🍝|🍠|🍢|🍣|🍤|🍥|🍡|🥟|🥠|🥡"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Gemüse", "", "submenu", "")
  sEmojis = "🥑|🍆|🥔|🥕|🌽|🌶️|🥒|🍄|🥜|🌰|🥦"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Geschirr", "", "submenu", "")
  sEmojis = "🍽️|🍴|🥄|🔪|🏺|🥢"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Getränke", "", "submenu", "")
  sEmojis = "🍼|🥛|☕|🍵|🍶|🍾|🍷|🍸|🍹|🍺|🍻|🥂|🥃|🥤"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Meeresfrüchte", "", "submenu", "")
  sEmojis = "🦀|🦐|🦑"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Obst", "", "submenu", "")
  sEmojis = "🥝|🍅|🍇|🍈|🍉|🍊|🍋|🍌|🍍|🍎|🍏|🍐|🍑|🍒|🍓|🥥"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("süße Speißen & Süßigkeiten", "", "submenu", "")
  sEmojis = "🍦|🍧|🍨|🍩|🍪|🎂|🍰|🍫|🍬|🍭|🍮|🍯|🥧"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("zubereitetes Essen (Mahlzeiten)", "", "submenu", "")
  sEmojis = "🍞|🥐|🥖|🥞|🧀|🍖|🍗|🥓|🍔|🍟|🍕|🌭|🌮|🌯|🥙|🥚|🍳|🥘|🍲|🥗|🍿|🥨|🥩|🥪|🥣|🥫"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor

CreateMenu ("Gesichter und Emotionen")
  CreateMenuEntry ("Affengesichter", "", "submenu", "")
  sEmojis = "🙈|🙉|🙊"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Besorgte Gesichter", "", "submenu", "")
  sEmojis = "😣|😥|😮|😯|😫|😓|😕|😲|☹️|🙁|😖|😞|😟|😢|😭|😦|😧|😨|😩|😰|😱|😳"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Emotionen", "", "submenu", "")
  sEmojis = "👁️‍🗨️|💋|💘|❤️|💓|💔|💕|💖|💗|💙|💚|💛|💜|🖤|💝|💞|💟|❣️|💌|💤|💢|💣|💥|💦|💨|💫|💬|🗨️|🗯️|💭|🕳️|💯|🧡"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Gesichter mit Accessoires", "", "submenu", "")
  sEmojis = "👁|😎|🤠|🤓|🧐"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Gesichter mit Hand", "", "submenu", "")
  sEmojis = "🤗|🤔|🤫|🤭"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Gesichter mit Zuneigung", "", "submenu", "")
  sEmojis = "😍|😘|😗|😙|😚|☺️|🤩"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Gesichter mit Zunge", "", "submenu", "")
  sEmojis = "😋|😛|😜|😝|🤑|🤪"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Katzengesichter", "", "submenu", "")
  sEmojis = "😺|😸|😹|😻|😼|😽|🙀|😿|😾"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("kostümierte Gesichter", "", "submenu", "")
  sEmojis = "🤡|👹|👺|👻|👽|👾|🤖|💩"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("lächelnde Gesichter", "", "submenu", "")
  sEmojis = "😁|😂|🤣|😃|😄|😅|😆|😉|😊|🙂|😀|🙃|😇"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("negative Gesichter", "", "submenu", "")
  sEmojis = "😤|😡|😠|😈|👿|💀|☠️|🤬"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
     
  CreateMenuEntry ("neutrale & skeptische Gesichter", "", "submenu", "")
  sEmojis = "😐|😑|😶|🙄|😏|🤐|😒|😬|🤥|🤨"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("schläfrige Gesichter", "", "submenu", "")
  sEmojis = "😪|😴|😌|🤤|😔"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("unwohle Gesichter", "", "submenu", "")
  sEmojis = "😵|😷|🤒|🤕|🤢|🤧|🤯|🤮"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
     
CreateMenu ("Objekte")
  CreateMenuEntry ("Bücher & Papier", "", "submenu", "")
  sEmojis = "📔|📕|📖|📗|📘|📙|📚|📓|📒|📃|📜|📄|📰|🗞️|📑|🔖|🏷️"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Büro", "", "submenu", "")
  sEmojis = "💼|📁|📂|🗂️|📅|📆|📎|🖇️|📏|📐|✂️|🗃️|🗄️|🗑️|🗒️|🗓️|📇|📈|📉|📊|📋|📌|📍"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Computer", "", "submenu", "")
  sEmojis = "🔋|🔌|💻|🖥️|🖨️|⌨️|🖱️|🖲️|💽|💾|💿|📀"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Haushalt", "", "submenu", "")
  sEmojis = "🛒|🚪|🛏️|🛋️|🚽|🚿|🛁"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Kleidung & Mode", "", "submenu", "")
  sEmojis = "👓|🕶️|👔|👕|👖|👗|👘|👙|👚|👛|👜|👝|🛍️|🎒|👞|👟|👠|👡|👢|👑|👒|🎩|🎓|⛑️|📿|💄|💍|💎|🧣|🧤|🧥|🧦|🧢"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Licht & Video", "", "submenu", "")
  sEmojis = "🎥|🎞️|📽️|🎬|📺|📷|📸|📹|📼|🔍|🔎|🕯️|💡|🔦|🏮"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor  
  CreateMenuEntry ("Medizin", "", "submenu", "")
  sEmojis = "💉|💊"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor  
  CreateMenuEntry ("Musik", "", "submenu", "")
  sEmojis = "🎼|🎵|🎶|🎙️|🎚️|🎛️|🎤|🎧|📻"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor  
  CreateMenuEntry ("Musikinstrumente", "", "submenu", "")
  sEmojis = "🎷|🎸|🎹|🎺|🎻|🥁"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Post & Mails", "", "submenu", "")
  sEmojis = "✉️|📧|📨|📩|📤|📥|📦|📫|📪|📬|📭|📮|🗳️"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Schlösser", "", "submenu", "")
  sEmojis = "🔒|🔓|🔏|🔐|🔑|🗝️"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Schreiberei", "", "submenu", "")
  sEmojis = "✏️|✒️|🖋️|🖊️|🖌️|🖍️|📝"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("sonstige Objekte", "", "submenu", "")
  sEmojis = "🚬|⚰️|⚱️|🗿"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Telefon", "", "submenu", "")
  sEmojis = "📱|📲|☎️|📞|📟|📠"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Ton", "", "submenu", "")
  sEmojis = "🔇|🔈|🔉|🔊|📢|📣|📯|🔔|🔕"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor 
  CreateMenuEntry ("Werkzeuge", "", "submenu", "")
  sEmojis = "🔨|⛏️|⚒️|🛠️|🗡️|⚔️|🔫|🏹|🛡️|🔧|🔩|⚙️|🗜️|⚖️|🔗|⛓️"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor 
  CreateMenuEntry ("Wissenschaft", "", "submenu", "")
  sEmojis = "🔬|🔭|📡|⚗️"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor 
    
CreateMenu ("Berufe & Lebensweisen")
  CreateMenuEntry ("Aktivitäten & Hobbies", "", "submenu", "")
  sEmojis = "💆|💇|🚶|🏃|💃|🕺|👯|🕴️|🧖|🧗|👨|👩"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Berufe & Lebensweisen", "", "submenu", "")
  sEmojis = "👨‍⚕️|👩‍⚕️|👨‍🎓|👩‍🎓|👨‍🏫|👩‍🏫|👨‍⚖️|👩‍⚖️|👨‍🌾|👩‍🌾|👨‍🍳|👩‍🍳|👨‍🔧|👩‍🔧|👨‍🏭|👩‍🏭|👨‍💼|👩‍💼|👨‍🔬|👩‍🔬|👨‍💻|👩‍💻|👨‍🎤|👩‍🎤|👨‍🎨|👩‍🎨|👨‍✈️|👩‍✈️|👨‍🚀|👩‍🚀|👨‍🚒|👩‍🚒|👮|👮‍👮|🕵️|💂|👷|🤴|👸|👳|👲|🤵|👰|🤰|🧕|🤱"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Erholung", "", "submenu", "")
  sEmojis = "🛀|🛌|🧘"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Fantasie & Märchen", "", "submenu", "")
  sEmojis = "👼|🎅|🤶|🧙|🧚|🧛|🧜|🧝|🧞|🧟"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Finger", "", "submenu", "")
  sEmojis = "👈|👉|☝️|👆|🖕|👇|✌️|🤞|🖖|🤘|🤙|🖐️|✋|👌|👍|👎|✊|👊|🤛|🤜|🤚|👋|🤟"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Gesten", "", "submenu", "")
  sEmojis = "🙍|🙎|🙅|🙆|💁|🙋|🙇|🤦|🤷"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Hände", "", "submenu", "")
  sEmojis = "👏|👐|🙌|🤝|🤲"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Körperteile", "", "submenu", "")
  sEmojis = "💪|👂|👃|👀|👁️|👅|👄|🧠"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Person: Symbol", "", "submenu", "")
  sEmojis = "🗣️|👤|👥|👣"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Personen", "", "submenu", "")
  sEmojis = "👶|👦|👧|👨|👩|👴|👵|👱|🧒|🧑|🧓|🧔|👨‍"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Personen beim Sport", "", "submenu", "")
  sEmojis = "🤺|🏇|⛷️|🏂|🏌️|🏄|🚣|🏊|⛹️|🏋️|🚴|🚵|🤹|🤸|🤼|🤽|🤾|🤹‍"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
 
CreateMenu ("Reisen und Orte")

  CreateMenuEntry ("Gebäude", "", "submenu", "")
  sEmojis = "🏟️|🏛️|🏗️|🏘️|🏚️|🏠|🏡|🏢|🏣|🏤|🏥|🏦|🏨|🏩|🏪|🏫|🏬|🏭|🏯|🏰|💒|🗼|🗽‍"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Geographie", "", "submenu", "")
  sEmojis = "🏔️|⛰️|🌋|🗻|🏕️|🏖️|🏜️|🏝️|🏞️‍"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Himmel & Wetter", "", "submenu", "")
  sEmojis = "🌌|🌑|🌒|🌓|🌔|🌕|🌖|🌗|🌘|🌙|🌚|🌛|🌜|🌡️|☀️|🌝|🌞|⭐|🌟|🌠|☁️|⛅|⛈️|🌤️|🌥️|🌦️|🌧️|🌨️|🌩️|🌪️|🌫️|🌬️|🌀|🌈|🌂|☂️|☔|⛱️|⚡|❄️|☃️|⛄|☄️|🔥|💧|🌊"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Landkarten", "", "submenu", "")
  sEmojis = "🌍|🌎|🌏|🌐|🗺️|🗾"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("religiöse Orte", "", "submenu", "")
  sEmojis = "⛪|🕌|🕍|⛩️|🕋"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("sonstige Orte", "", "submenu", "")
  sEmojis = "🏙️|⛲|⛺|🌁|🌃|🌄|🌅|🌆|🌇|🌉|♨️|🎠|🎡|🎢|💈|🎪"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Transport: Land", "", "submenu", "")
  sEmojis = "🏎️|🏍️|🛢️|🚂|🚃|🚄|🚅|🚆|🚇|🚈|🚉|🚊|🚝|🚞|🚋|🚌|🚍|🚎|🚐|🚑|🚒|🚓|🚔|🚕|🚖|🚗|🚘|🚙|🚚|🚛|🚜|🚲|🛴|🛵|🚏|🛣️|🛤️|⛽|🚨|🚥|🚦|🚧|🛑"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Transport: Luft", "", "submenu", "")
  sEmojis = "✈️|🛩️|🛫|🛬|💺|🚁|🚟|🚠|🚡|🛰️|🚀|🛸"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Transport: Wasser", "", "submenu", "")
  sEmojis = "⚓|⛵|🛶|🚤|🛳️|⛴️|🛥️|🚢"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
  CreateMenuEntry ("Uhrzeit", "", "submenu", "")
  sEmojis = "⌛|⏳|⌚|⏰|⏱️|⏲️|🕰️|🕛|🕧|🕐|🕜|🕑|🕝|🕒|🕞|🕓|🕟|🕔|🕠|🕕|🕡|🕖|🕢|🕗|🕣|🕘|🕤|🕙|🕥|🕚|🕦"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor
        
CreateMenu ("Symbole und Zeichen")
  CreateMenuEntry ("alphanumerische Zeichen", "", "submenu", "")
  sEmojis = "🔠|🔡|🔢|🔣|🔤|🅰️|🆎|🅱️|🆑|🆒|🆓|ℹ️|🆔|Ⓜ️|🆕|🆖|🅾️|🆗|🅿️|🆘|🆙|🆚|🈁|🈂️|🈷️|🈶|🈯|🉐|🈹|🈚|🈲|🉑|🈸|🈴|🈳|㊗️|㊙️|🈺|🈵️"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("audiovisuelle Symbole", "", "submenu", "")
  sEmojis = "️🔀|🔁|🔂|▶️|⏩|⏭️|⏯️|◀️|⏪|⏮️|🔼|⏫|🔽|⏬|⏸️|⏹️|⏺️|⏏️|🎦|🔅|🔆|📶|📳|📴"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("geometrische Symbole", "", "submenu", "")
  sEmojis = "️▪️|▫️|◻️|◼️|◽|◾|⬛|⬜|🔶|🔷|🔸|🔹|🔺|🔻|💠|🔘|🔲|🔳|⚪|⚫|🔴|🔵"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor      
  CreateMenuEntry ("Geschlechter", "", "submenu", "")
  sEmojis = "️♀️|♂️"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("Hinweisschilder", "", "submenu", "")
  sEmojis = "️🏧|🚮|🚰|♿|🚹|🛃|🛄|🛅|🚺|🚻|🚼|🚾|🛂"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor      
  CreateMenuEntry ("Pfeile", "", "submenu", "")
  sEmojis = "️⬆️|↗️|➡️|↘️|⬇️|↙️|⬅️|↖️|↕️|↔️|↩️|↪️|⤴️|⤵️|🔃|🔄|🔙|🔚|🔛|🔜|🔝"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("Religion", "", "submenu", "")
  sEmojis = "️🛐|⚛️|🕉️|✡️|☸️|☯️|✝️|☦️|☪️|☮️|🕎|🔯"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("sonstige Symbole", "", "submenu", "")
  sEmojis = "️⚕️|♻️|⚜️|🔱|📛|🔰|⭕|✅|☑️|✔️|✖️|❌|❎|➕|➖|➗|➰|➿ 〽️|✳️|✴️|❇️|‼️|⁉️|❓|❔|❕|❗|〰️|©️|®️|™️|♾️"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("Telefontastatur", "", "submenu", "")
  sEmojis = "️#️⃣|*️⃣|0️⃣|1️⃣|2️⃣|3️⃣|4️⃣|5️⃣|6️⃣|7️⃣|8️⃣|9️⃣|🔟"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("Tierkreiszeichen & Sternzeichen", "", "submenu", "")
  sEmojis = "️♈|♉|♊|♋|♌|♍|♎|♏|♐|♑|♒|♓|⛎"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("Warnungen", "", "submenu", "")
  sEmojis = "️⚠️|🚸|⛔|🚫|🚳|🚭|🚯|🚱|🚷|📵|🔞|☢️|☣️"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor   

CreateMenu ("Tiere und Natur")
  
  CreateMenuEntry ("Amphibien", "", "submenu", "")
  sEmojis = "️🐸"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("Blumen", "", "submenu", "")
  sEmojis = "️💐|🌸|💮|🏵️|🌹|🥀|🌺|🌻|🌼|🌷"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("kleine Tierchen", "", "submenu", "")
  sEmojis = "️🐌|🦋|🐛|🐜|🐝|🐞|🕷️|🕸️|🦂|🦗"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("Meerestiere", "", "submenu", "")
  sEmojis = "️🐳|🐋|🐬|🐟|🐠|🐡|🦈|🐙|🐚"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("Pflanzen", "", "submenu", "")
  sEmojis = "️🌱|🌲|🌳|🌴|🌵|🌾|🌿|☘️|🍀|🍁|🍂|🍃"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("Reptilien", "", "submenu", "")
  sEmojis = "️🐊|🐢|🦎|🐍|🐲|🐉|🦕|🦖"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor     
  CreateMenuEntry ("Säugetiere", "", "submenu", "")
  sEmojis = "️🐵|🐒|🦍|🐶|🐕|🐩|🐺|🦊|🐱|🐈|🦁|🐯|🐅|🐆|🐴|🐎|🦄|🦌|🐮|🐂|🐃|🐄|🐷|🐖|🐗|🐽|🐏|🐑|🐐|🐪|🐫|🐘|🦏|🐭|🐁|🐀|🐹|🐰|🐇|🐿️|🦇|🐻|🐨|🐼|🐾|🦓|🦒|🦔|🐕‍"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor          
  CreateMenuEntry ("Vögel", "", "submenu", "")
  sEmojis = "️🦃|🐔|🐓|🐣|🐤|🐥|🐦|🐧|🕊️|🦅|🦆|🦉"
     for i=1 to StringSegmentCount (sEmojis, "|")
     sChar = StringSegment (sEmojis, "|", i)
     CreateSubMenuEntry(sChar, "", "function", "TypeString|"+sChar)
     endFor   

StartMenuLayer()
EndScript

; -------------------------------------------------------------------------------------------------------
; Beispiel zum Anzeigen des Favoriten-Menüs
; -------------------------------------------------------------------------------------------------------

void Function RunShellExecute (string sFilename)
var
object oShell = CreateObject("Shell.Application") 
oShell.ShellExecute(sFilename, "", "", "open", 2)
EndFunction


Script StartFavoritesMenu ()
var
object oShell = CreateObject("Wscript.Shell"),
string sPath = oShell.SpecialFolders("Favorites"),
object oFSO = CreateObject("Scripting.FileSystemObject"),
object oFolder,
object oFolders = oFSO.GetFolder (sPath),
object oFile,
object oFiles, 
string sFile,
string sFolder

if giMenus then
PerformScript FindChar(GetCurrentScriptKeyName ())
Return
EndIf 

NewXMLMenu ("Lesezeichen")

  ForEach oFolder in oFolders.SubFolders
  CreateMenu (oFolder.Name)
  sFolder = oFolder.Path
        ForEach oFile in oFolder.Files
        sFile = oFile.Name
        CreateMenuEntry (oFile.Name, "", "function", "RunShellExecute|" + sfolder + "\\" +sFile)
        EndForEach
  EndForEach 
StartMenuLayer()
EndScript

; -------------------------------------------------------------------------------------------------------
; Beispiel zum Anzeigen der Taskleiste als Menü
; -------------------------------------------------------------------------------------------------------

globals
 object goTray
 
void Function SelectTrayObject (int iNumber)
If !goTray == Null () then
goTray (iNumber).GetInvokePattern().Invoke
EndIf
EndFunction
 
Script StartSymbolsMenu ()
; Shift+Space&m&s*=StartSymbolsMenu
 
var
string sTrayClass = "Shell_TrayWnd",
handle hTray = FindTopLevelWindow(sTrayClass, "")
 
if giMenus then
PerformScript FindChar(GetCurrentScriptKeyName ())
Return
EndIf
 
NewXMLMenu ("Taskleiste")
 
if !hTray then
Return
endIf
 
var
	object oUIA,
	object oElements,
    object oCondition,
	object oEntry,
	string sControlType,
	string sName,
	int i = 0,
	int iDone = False
 
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
if !oUIA then
Return
EndIf
 
oElements = oUIA.GetElementFromHandle(hTray)
if !oElements then
Return
EndIf
 
oCondition = oUIA.CreateNotCondition (oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, UIA_PaneControlTypeId))
if !oCondition then
Return
EndIf
 
oElements = oElements.FindAll (treeScope_descendants, oCondition)
 
CreateMenu ("Menü")
 
goTray = oElements
 
ForEach oEntry in oElements
 
sName = oEntry.Name
sControlType = oEntry.ControlType
 
If !iDone && StringContains (sname, "Chevron-") then
CreateMenu ("Symbolleisten")
iDone = True
EndIf
 
 
sName = StringReplaceSubstrings (sName, "Chevron-", "")
 
If sControlType == IntToString (UIA_ToolBarControlTypeId) then
CreateMenu (sName)
else
       CreateMenuEntry (sName, "", "function", "SelectTrayObject|" + IntToString(i))
EndIf
 
i = i + 1
EndForEach
  
StartMenuLayer()
EndScript


; -------------------------------------------------------------------------------------------------------
; Beispiel zum Anzeigen eines Menüs in Chrome und Edge
; -------------------------------------------------------------------------------------------------------

void Function TypeKeys (string sKeySection)
var
int i,
string sKey
 Delay (5)
for i=1 to StringSegmentCount (sKeySection, "&")
sKey = StringSegment (sKeySection, "&", i)
TypeKey (sKey)
Pause ()
Delay (2)

EndFor
EndFunction

Function TypeURL (string sURL)
TypeKey ("Control+T")
var
object oUIA,
object oElements,
object oEntry,
object oCondition
 
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetAppMainWindow(GetFocus()))
 
If !oElements then Return EndIf
oCondition = oUIA.CreateStringPropertyCondition (UIA_NamePropertyId, "Adress- und Suchleiste")
If !oCondition then Return Endif
oEntry = oElements.FindFirst (TreeScope_Descendants, oCondition)
If !oEntry then Return Endif

If oEntry.SetFocus () then
TypeString (sURL)
Pause ()
; TypeKey ("Enter")
EnterKey ()
ScheduleFunction ("StopSpeech", 10, True)
EndIf 
EndFunction

Const
cAppButton = "Apps"

int Function IsBookmarkBar ()
var
object oUIA,
object oElements,
object oEntry,
object oCondition
 
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetAppMainWindow(GetFocus()))
 
If !oElements then Return False EndIf

If !oElements then Return EndIf
oCondition = oUIA.CreateAndCondition (oUIA.CreateStringPropertyCondition (UIA_NamePropertyId, cAppButton),  oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId))

If !oCondition then Return False Endif
oEntry = oElements.FindAll (TreeScope_Descendants, oCondition)
; SayInteger (oEntry.Count)
If oEntry.Count > 0 then 
Return True
else
Return False 
Endif
EndFunction 

int Function IsBookmarkBarEdge ()
var
object oUIA,
object oElements,
object oEntry,
object oCondition
 
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetAppMainWindow(GetFocus()))
 
If !oElements then Return False EndIf

If !oElements then Return EndIf

oCondition = oUIA.CreateOrCondition (
oUIA.CreateStringPropertyCondition (UIA_ClassNamePropertyId, "BookmarkButton"), 
oUIA.CreateStringPropertyCondition (UIA_ClassNamePropertyId, "MenuButton"))

If !oCondition then Return False Endif
oEntry = oElements.FindAll (TreeScope_Descendants, oCondition)
; SayInteger (oEntry.Count)
If oEntry.Count > 0 then 
Return True
else
Return False 
Endif
EndFunction 


int Function IsPDFView ()
var
object oUIA,
object oElements,
object oEntry,
object oCondition
 
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetAppMainWindow(GetFocus()))
 
If !oElements then Return False EndIf

If !oElements then Return EndIf
oCondition = oUIA.CreateAndCondition (oUIA.CreateStringPropertyCondition (UIA_NamePropertyId, cAppButton),  oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId))

If !oCondition then Return False Endif
oEntry = oElements.FindAll (TreeScope_Descendants, oCondition)
; SayInteger (oEntry.Count)
If oEntry.Count > 1 then 
Return True
else
Return False 
Endif
EndFunction 


int Function IsStartPage ()
var
object oUIA,
object oElements,
object oEntry,
object oCondition
 
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetAppMainWindow(GetFocus()))
 
If !oElements then Return False EndIf

If !oElements then Return EndIf
oCondition = oUIA.CreateAndCondition (oUIA.CreateStringPropertyCondition (UIA_NamePropertyId, cAppButton),  oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId))

If !oCondition then Return False Endif
oEntry = oElements.FindAll (TreeScope_Descendants, oCondition)
; SayInteger (oEntry.Count)
If oEntry.Count > 1 then 
Return True
else
Return False 
Endif
EndFunction 

void Function FillBookmarks ()
var
object oUIA,
; object oTree, 
object oElements, 
object oEntry, 
object oCondition, 
object oRect, 
int iTop, 
int iLeft, 
int iBegin
 
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetAppMainWindow(GetFocus()))
 
if !oElements then Return EndIf
oCondition = oUIA.CreateOrCondition (oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId), 
oUIA.CreateIntPropertyCondition (UIA_ControlTypePropertyId, UIA_MenuItemControlTypeId))

If !oCondition then Return Endif
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
iBegin = False 
ForEach oEntry in oElements 
If iBegin then 
oRect = oEntry.BoundingRectangle
iLeft = oRect.Left+5
iTop = oRect.Top+5
CreateSubMenuEntry(oEntry.Name, "", "mouseclick", IntToString(iLeft)+"|"+IntToString(iTop))
EndIf 

If oEntry.Name == "Chrome" then 
iBegin = True 
EndIf
; AppendToClipboard (oEntry.Name, True)
EndForEach 
EndFunction

void Function FillBookmarksEdge ()
var
object oUIA,
; object oTree, 
object oElements, 
object oEntry, 
object oCondition, 
object oRect, 
int iTop, 
int iLeft
 
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
oElements = oUIA.GetElementFromHandle (GetAppMainWindow(GetFocus()))
 
if !oElements then Return EndIf
oCondition = oUIA.CreateOrCondition (
oUIA.CreateStringPropertyCondition (UIA_ClassNamePropertyId, "BookmarkButton"), 
oUIA.CreateStringPropertyCondition (UIA_ClassNamePropertyId, "MenuButton"))

If !oCondition then Return Endif
oElements = oElements.FindAll (TreeScope_Descendants, oCondition)
ForEach oEntry in oElements 
oRect = oEntry.BoundingRectangle
iLeft = oRect.Left+5
iTop = oRect.Top+5
CreateSubMenuEntry(oEntry.Name, "", "mouseclick", IntToString(iLeft)+"|"+IntToString(iTop))
EndForEach 

EndFunction



Script StartChromeMenu ()

var
int bEdge
 
if giMenus then
PerformScript FindChar(GetCurrentScriptKeyName ())
Return
EndIf
 
; https://support.google.com/chrome/answer/157179?hl=de
 
If StringLower (GetAppFileName ()) == "msedge.exe" then
NewXMLMenu ("Edge Menü")
bEdge = True
else
NewXMLMenu ("Google Chrome Menü")
bEdge = False 
EndIf 
 
CreateMenu ("Datei")
       CreateMenuEntry ("Neues Fenster", "Strg+N", "function", "TypeKey|Control+N")
       CreateMenuEntry ("Inkognitomodus", "Strg+Umschalt+N", "function", "TypeKey|Control+Shift+N")
       CreateMenuEntry ("Öffnen", "Strg+O", "function", "TypeKeys|Control+O")
       CreateMenuEntry ("Nutzer wechseln/als Gast surfen", "Strg+Umschalttaste+M", "function", "TypeKeys|Control+Shift+M")
       CreateMenuEntry ("Startseite", "Alt+Pos1", "function", "TypeKey|Alt+Home")
       CreateMenuEntry ("Drucken", "Strg+P", "function", "TypeKeys|Control+P")
       
       If bEdge then
       CreateMenuEntry ("Drucken über System", "Strg+Umschalt+P", "function", "TypeKeys|Control+Shift+P")
       EndIf 
       
       CreateMenuEntry ("Speichern", "Strg+S", "function", "TypeKeys|Control+S")
       CreateMenuEntry ("Fenster schließen", "Strg+Umschalttaste+W oder Alt+F4", "function", "TypeKey|Alt+F4")
       CreateMenuEntry ("Fenster minimieren", "Alt+Leertaste, dann N", "function", "TypeKeys|Alt+Space&N")
       CreateMenuEntry ("Fenster maximieren", "Alt+Leertaste, dann X", "function", "TypeKeys|Alt+Space&X")

       If bEdge then
       CreateMenuEntry ("Edge beenden", "Alt+F4", "function", "TypeKeys|Alt+F4")
       else
       CreateMenuEntry ("Google Chrome beenden", "Alt+F, dann X", "function", "TypeKeys|Alt+F&X")
       EndIf 

CreateMenu ("Bearbeiten")  
       CreateMenuEntry ("Seite im Cache neu laden", "F5 oder Strg+R", "function", "TypeKeys|F5")
       CreateMenuEntry ("Seite komplett neu laden", "Umschalttaste+F5 oder Strg+Umschalttaste+R", "function", "TypeKeys|Shift+F5")
       CreateMenuEntry ("Laden stoppen", "Esc", "function", "TypeKeys|Escape")
       CreateMenuEntry ("Vor", "Alt+Linkspfeil", "function", "TypeKey|Alt+LeftArrow")
       CreateMenuEntry ("Zurück", "Alt+Rechtspfeil", "function", "TypeKey|Alt+RightArrow")
       CreateMenuEntry ("Seite durchsuchen", "Strg+F oder F3", "function", "TypeKeys|F3")
       CreateMenuEntry ("Nächster Treffer", "Strg+G", "function", "TypeKeys|Control+G")
       CreateMenuEntry ("Vorheriger Treffer", "Strg+Umschalttaste+G", "function", "TypeKeys|Control+Shift+G")
       CreateMenuEntry ("Nächstes Element", "Tabulatortaste", "function", "TypeKeys|Tab")
       CreateMenuEntry ("Voheriges Element", "Umschalttaste+Tabulatortaste", "function", "TypeKeys|Shift+Tab")
       
       If bEdge then
       CreateMenuEntry ("Tastaturnavigation", "F7", "function", "TypeKey|F7")       
       EndIf 
  
CreateMenu ("Ansicht")    
       CreateMenuEntry ("Vollbildmodus", "F11", "function", "TypeKeys|F11")
       CreateMenuEntry ("Zoom vergrößern", "Strg und +", "function", "TypeKeys|Control+NumPadPlus")
       CreateMenuEntry ("Zoom verkleinern", "Strg und -", "function", "TypeKeys|Control+NumPadMinus")
       CreateMenuEntry ("Zoom Standardgröße", "Strg+0", "function", "TypeKeys|Control+0")
       CreateMenuEntry ("Seite nach unten scrollen", "Leertaste oder Bild-ab-Taste", "function", "TypeKeys|Space")
       CreateMenuEntry ("Seite nach oben scrollen", "Umschalttaste+Leertaste oder Bild-auf-Taste", "function", "TypeKeys|Shift+Space")
       CreateMenuEntry ("Anfang der Seite", "Pos1", "function", "TypeKeys|Home")
       CreateMenuEntry ("Ende der Seite", "Ende", "function", "TypeKeys|End")
       
CreateMenu ("Symbolleiste")
       CreateMenuEntry ("Erstes Element der Symbolleiste", "Umschalttaste+Alt+T", "function", "TypeKeys|Alt+Shift+T")
       CreateMenuEntry ("Letztes Element der Symbolleiste", "F10", "function", "TypeKeys|F10")
       CreateMenuEntry ("Dialogfeld ohne Fokus fokussieren", "F6", "function", "TypeKeys|F6")
       CreateMenuEntry ("Adressleiste", "Strg+l oder Alt+d oder F6", "function", "TypeKeys|Control+I")
       CreateMenuEntry ("Adressleiste mit Suche", "Strg+K oder Strg+E", "function", "TypeKeys|Control+K")
       CreateMenuEntry ("Cursor in die Adressleiste bewegen", "Strg+L", "function", "TypeKeys|Control+L")

CreateMenu ("Tabs")       
       CreateMenuEntry ("Neuer Tab", "Strg+T", "function", "TypeKey|Control+T")
       CreateMenuEntry ("Zuletzt geschlossenen Tab öffnen", "Strg+Umschalttaste+T", "function", "TypeKey|Control+Shift+T")
       CreateMenuEntry ("Nächster Tab", "Strg+Tabulatortaste oder Strg+Bild-ab-Taste", "function", "TypeKey|Control+Tab")
       CreateMenuEntry ("Vorheriger Tab", "Strg+Umschalttaste+Tabulatortaste oder Strg+Bild-auf-Taste ", "function", "")
       CreateMenuEntry ("Letzter Tab", "Strg+9", "function", "TypeKey|Control+9")
       CreateMenuEntry ("Tab schließen", "Strg+§ oder Strg+F4", "function", "TypeKey|Control+F4")
 
CreateMenu ("Lesezeichen")
       if bEdge then
       ; Edge
       If IsBookmarkBarEdge () then
       CreateMenuEntry ("Lesezeichenleiste ausblenden", "Strg+Umschalttaste+B", "function", "TypeKeys|Control+Shift+B")
       else
       CreateMenuEntry ("Lesezeichenleiste einblenden", "Strg+Umschalttaste+B", "function", "TypeKeys|Control+Shift+B")
       EndIf 
       else
       ; Google
       If IsBookmarkBar () then
       CreateMenuEntry ("Lesezeichenleiste ausblenden", "Strg+Umschalttaste+B", "function", "TypeKeys|Control+Shift+B")
       else
       CreateMenuEntry ("Lesezeichenleiste einblenden", "Strg+Umschalttaste+B", "function", "TypeKeys|Control+Shift+B")
       EndIf 

       EndIf 
       
       CreateMenuEntry ("Lesezeichenmanager", "Strg+Umschalttaste+O", "function", "TypeKeys|Control+Shift+O")
       CreateMenuEntry ("Als Lesezeichen speichern", "Strg+D", "function", "TypeKeys|Control+D")
       CreateMenuEntry ("Alle Tabs als Lesezeichen", "Strg+Umschalttaste+D", "function", "TypeKeys|Control+Shift+D")

       if IsBookmarkBar () then
       CreateMenuEntry ("Lesezeichen", "", "submenu", "")
       FillBookmarks ()
       EndIf 

       if IsBookmarkBarEdge () then
       CreateMenuEntry ("Lesezeichen", "", "submenu", "")
       FillBookmarksEdge ()
       EndIf 

CreateMenu ("Extras")

       If bEdge then
       CreateMenuEntry ("Edge-Menü", "Alt+F oder Alt+E", "function", "TypeKeys|Alt+F")
       else
       CreateMenuEntry ("Chrome-Menü", "Alt+F oder Alt+E", "function", "TypeKeys|Alt+F")
       CreateMenuEntry ("Datenschutz", "", "function", "TypeURL|chrome://settings/content/")
       CreateMenuEntry ("Erweiterungen", "", "function", "TypeURL|chrome://extensions/")
       EndIf 
       
       CreateMenuEntry ("Task-Manager", "Umschalttaste+Esc-Taste", "function", "TypeKeys|Shift+Escape")
       CreateMenuEntry ("Einstellungen", "Alt+F, dann E", "function", "TypeKeys|Alt+F&E")
       CreateMenuEntry ("Verlauf", "Strg+H", "function", "TypeKeys|Control+H")
       CreateMenuEntry ("Downloads", "Strg+J", "function", "TypeKeys|Control+J")
       CreateMenuEntry ("Browserdaten löschen", "Strg+Umschalttaste+Entf", "function", "TypeKeys|Control+Shift+Delete")
       CreateMenuEntry ("Hilfe", "F1", "function", "TypeKeys|F1")
       CreateMenuEntry ("Feedbackformular öffnen", "Alt+Umschalttaste+I", "function", "TypeKeys|Alt+Shift+I")
            
CreateMenu ("Entwickler")       
       CreateMenuEntry ("Entwicklertools", "Strg+Umschalttaste+J oder F12", "function", "TypeKeys|F12")
       CreateMenuEntry ("Seiten-Quelltext", "Strg+U", "function", "TypeKeys|Control+U")
       
StartMenuLayer()
EndScript

